;MaxFontsHeight = 16
;MaxMouseWidth = 16

MinMenuDx	EQU	70
BDColor		EQU	7

DefWidth	EQU	640
DefHeight	EQU	256
DefDepth	EQU	3
DefVModes	EQU	$8000

MouseW		EQU	16
MouseH		EQU	12

bmf_MASK	EQU	1
bmf_LOCK	EQU	2

wf_QUIET	EQU	1
wf_ACTIVE	EQU	2
wf_NOBLUE	EQU	4
wf_NODRAG	EQU	8
wf_CENTRE	EQU	16
wf_FIRST	EQU	32

gl_END		EQU	0
gl_LINEH	EQU	1
gl_LINEV	EQU	2
gl_BOX		EQU	3
gl_BAR		EQU	4
gl_BOX3D	EQU	5
gl_BAR3D	EQU	6
gl_TEXT		EQU	7
gl_IMAGE	EQU	8

STRUCTURE	MACRO
\1		EQU	0
SOFFSET		SET     \2
		ENDM

BYTE		MACRO
\1		EQU	SOFFSET
SOFFSET		SET	SOFFSET+1
		ENDM

SBYTE		MACRO
\1		EQU	SOFFSET
SOFFSET		SET	SOFFSET+1
		ENDM

WORD		MACRO
\1		EQU	SOFFSET
SOFFSET		SET	SOFFSET+2
		ENDM

SWORD		MACRO
\1		EQU	SOFFSET
SOFFSET		SET	SOFFSET+2
		ENDM

LONG		MACRO
\1		EQU	SOFFSET
SOFFSET		SET	SOFFSET+4
		ENDM

SLONG		MACRO
\1		EQU	SOFFSET
SOFFSET		SET	SOFFSET+4
		ENDM

APTR		MACRO
\1		EQU	SOFFSET
SOFFSET		SET	SOFFSET+4
		ENDM

STRUCT		MACRO
\1		EQU	SOFFSET
SOFFSET		SET	SOFFSET+\2
		ENDM

LABEL		MACRO
\1		EQU	SOFFSET
		ENDM

gf_ONOFF	EQU	1
gf_UNACTIVE	EQU	2
gf_SWITCH	EQU	4
gf_LINK		EQU	8

gt_EASY		EQU	1
gt_BOX		EQU	2
gt_IMAGE	EQU	3

	STRUCTURE Gadget,0
		APTR	gd_Next
		APTR	gd_Jsr
		APTR	gd_Link
		WORD	gd_LeftEdge
		WORD	gd_TopEdge
		WORD	gd_Width
		WORD	gd_Height
		BYTE	gd_Type
		BYTE	gd_Flags
	LABEL GD_SIZE

	STRUCTURE BitMap,0
		WORD	bm_Width
		WORD	bm_Height
		WORD	bm_BPR
		BYTE	bm_Depth
		BYTE	bm_Flags
		STRUCT	bm_Planes,32
		APTR	bm_Mask
	LABEL BM_SIZE

	STRUCTURE NewWindow,0
		APTR	nw_Name
		APTR	nw_Menu
		APTR	nw_Gadgets
		APTR	nw_GfxList
		WORD	nw_LeftEdge
		WORD	nw_TopEdge
		WORD	nw_Width
		WORD	nw_Height
		WORD	nw_MinWidth
		WORD	nw_MinHeight
		WORD	nw_MaxWidth
		WORD	nw_MaxHeight
		WORD	nw_Flags
	LABEL NW_SIZE

	STRUCTURE Window,0
		APTR	wi_Next
		STRUCT	wi_BitMap,BM_SIZE
		APTR	wi_Name
		APTR	wi_Menu
		APTR	wi_Gadgets
		APTR	wi_GfxList
		WORD	wi_LeftEdge
		WORD	wi_TopEdge
		WORD	wi_Width
		WORD	wi_Height
		WORD	wi_MinWidth
		WORD	wi_MinHeight
		WORD	wi_MaxWidth
		WORD	wi_MaxHeight
		WORD	wi_Flags
		WORD	wi_MinX
		WORD	wi_MinY
		WORD	wi_MaxX
		WORD	wi_MaxY
		WORD	wi_ClipMinX
		WORD	wi_ClipMinY
		WORD	wi_ClipMaxX
		WORD	wi_ClipMaxY
	LABEL WI_SIZE

ExcFindTask		equ	-294
ExcWaitPort		equ	-384
ExcGetMsg		equ	-372
ExcReplyMsg		equ	-378
ExcForbid		equ	-132
ExcOldOpenLibrary	equ	-408
ExcCloseLibrary		equ	-414
ExcAllocMem		equ	-198
ExcFreeMem		equ	-210

DosOpen			equ	-30
DosClose		equ	-36
DosRead			equ	-42
DosWrite		equ	-48

IntOpenScreen		equ	-198
IntCloseScreen		equ	-66
IntOpenWindow		equ	-204
IntCloseWindow		equ	-72
IntSetPointer		equ	-270

GfxSetRGB4		equ	-288
GfxWaitTOF		equ	-270

MODE_OLD		equ	1005
MODE_NEW		equ	1006

MEM_PUBLIC		equ	$1
MEM_CHIP		equ	$2
MEM_FAST		equ	$4
MEM_CLEAR		equ	$10000

MOUSEBUTTONS		equ	$8
RAWKEY			equ	$400

CallExe	MACRO
	move.l	ExcBase,a6
	jsr	Exc\1(a6)
	ENDM

CallDos	MACRO
	move.l	DosBase,a6
	jsr	Dos\1(a6)
	ENDM

CallInt	MACRO
	move.l	IntBase,a6
	jsr	Int\1(a6)
	ENDM

CallGfx	MACRO
	move.l	GfxBase,a6
	jsr	Gfx\1(a6)
	ENDM

*************************************************************************

	SECTION	CODE,CODE

Start:	jmp	Begin

*************************************************************************

Procedures:
	jmp	Halt
	jmp	AllocMem
	jmp	FreeMem
	jmp	SetRGB
	jmp	SetPixel
	jmp	ClrPixel
	jmp	ChgPixel

*************************************************************************

Halt:
	jmp	_Halt

*************************************************************************

;In:
;	d0.l - rozmiar
;Out:
;	d0/a0.l - adres
AllocMem:
	btst	#0,d0
	beq.s	AlMe1
	addq.l	#1,d0
AlMe1:	addq.l	#8,d0
	move.l	d0,-(sp)
	move.l	#MEM_PUBLIC,d1
	CallExe	AllocMem
	move.l	(sp)+,d1
	move.l	d0,a0
	tst.l	d0
	beq.s	AlMe0
	move.l	MemList,(a0)
	move.l	a0,MemList
	move.l	d1,4(a0)
	addq.l	#8,d0
	move.l	d0,a0
AlMe0:	rts

*************************************************************************

;In:
;	a0.l - adres
FreeMem:
	cmpa.l	#0,a0
	beq.s	FrMe0
	tst.l	MemList
	beq.s	FrMe0
	suba.l	#8,a0
	lea	MemList,a1
FrMe1:	cmp.l	(a1),a0
	bne.s	FrMe2
	move.l	(a0),(a1)
	move.l	4(a0),d0
	move.l	a0,a1
	CallExe	FreeMem
	rts
FrMe2:	move.l	(a1),a1
	cmp.l	#0,(a1)
	bne	FrMe1
FrMe0:	rts

*************************************************************************

WaitTOF:
	CallGfx	WaitTOF
	rts

*************************************************************************

;In:
;	d0.b - rejestr
;	d1.w - $RGB
SetRGB:
	and.l	#$f,d0
	move.l	d1,d2
	move.l	d1,d3
	lsr.w	#8,d1
	lsr.w	#4,d2
	and.l	#$f,d1
	and.l	#$f,d2
	and.l	#$f,d3
	move.l	__Screen,a0
	lea	44(a0),a0
	CallGfx	SetRGB4
	rts

*************************************************************************

;In:
;	a0.l - BitMap
;	d0.w - x
;	d1.w - y
;	d2.b - plane num
SetPixel:
	mulu.w	bm_BPR(a0),d1
	ext.l	d0
	move.l	d0,d3
	lsr.w	#3,d0
	add.l	d0,d1
	moveq	#7,d4
	and.l	d4,d3
	sub.b	d3,d4
	ext.w	d2
	lsl.w	#2,d2
	move.l	bm_Planes(a0,d2.w),a0
	add.l	d1,a0
	bset	d4,(a0)
	rts

*************************************************************************

;In:
;	a0.l - BitMap
;	d0.w - x
;	d1.w - y
;	d2.b - plane num
ClrPixel:
	mulu.w	bm_BPR(a0),d1
	ext.l	d0
	move.l	d0,d3
	lsr.w	#3,d0
	add.l	d0,d1
	moveq	#7,d4
	and.l	d4,d3
	sub.b	d3,d4
	ext.w	d2
	lsl.w	#2,d2
	move.l	bm_Planes(a0,d2.w),a0
	add.l	d1,a0
	bclr	d4,(a0)
	rts

*************************************************************************

;In:
;	a0.l - BitMap
;	d0.w - x
;	d1.w - y
;	d2.b - plane num
ChgPixel:
	mulu.w	bm_BPR(a0),d1
	ext.l	d0
	move.l	d0,d3
	lsr.w	#3,d0
	add.l	d0,d1
	moveq	#7,d4
	and.l	d4,d3
	sub.b	d3,d4
	ext.w	d2
	lsl.w	#2,d2
	move.l	bm_Planes(a0,d2.w),a0
	add.l	d1,a0
	bchg	d4,(a0)
	rts

*************************************************************************

;In:
;	a0.l - BitMap
;	d0.w - x
;	d1.w - y
;	d2.w - dx
;	d3.w - dy
;	d4.b - plane num
PlaneSet:
	mulu.w	bm_BPR(a0),d1
	ext.l	d0
	move.l	d0,d5
	lsr.w	#3,d5
	add.l	d5,d1
	moveq	#0,d7
	move.w	bm_BPR(a0),d7
	ext.w	d4
	lsl.w	#2,d4
	move.l	bm_Planes(a0,d4.w),a0
	add.l	d1,a0

	move.w	d0,d4
	and.l	#7,d4
	moveq	#8,d5
	sub.b	d4,d5

	cmp.w	d5,d2
	bhi.s	PlSe4
	moveq	#0,d6
	move.w	d2,d6
	moveq	#0,d2
	bra.s	PlSe5

PlSe4:	sub.w	d5,d2
	move.w	d2,d6
	and.l	#7,d6
	add.b	d5,d6
	lsr.w	#3,d2

PlSe5:	move.l	#$ffff0000,d5
	lsr.l	d6,d5
	and.l	#$0000ffff,d5
	lsr.l	d4,d5

	move.b	d5,d6
	lsr.w	#8,d5

PlSe1:	movea.l	a0,a1
	add.l	d7,a0

	or.b	d5,(a1)+
	move.b	d2,d1
PlSe3:	tst.b	d1
	beq.s	PlSe2
	st	(a1)+
	subq.b	#1,d1
	bne.s	PlSe3
PlSe2:	or.b	d6,(a1)+

	subq.w	#1,d3
	bne.s	PlSe1
	rts

*************************************************************************

;In:
;	a0.l - BitMap
;	d0.w - x
;	d1.w - y
;	d2.w - dx
;	d3.w - dy
;	d4.b - plane num
PlaneClr:
	mulu.w	bm_BPR(a0),d1
	ext.l	d0
	move.l	d0,d5
	lsr.w	#3,d5
	add.l	d5,d1
	moveq	#0,d7
	move.w	bm_BPR(a0),d7
	ext.w	d4
	lsl.w	#2,d4
	move.l	bm_Planes(a0,d4.w),a0
	add.l	d1,a0

	move.w	d0,d4
	and.l	#7,d4
	moveq	#8,d5
	sub.b	d4,d5

	cmp.w	d5,d2
	bhi.s	PlCl4
	moveq	#0,d6
	move.w	d2,d6
	moveq	#0,d2
	bra.s	PlCl5

PlCl4:	sub.w	d5,d2
	move.w	d2,d6
	and.l	#7,d6
	add.b	d5,d6
	lsr.w	#3,d2

	;d6 - ile "1"
	;d4 - ile "0"

PlCl5:	move.l	#$ffff0000,d5
	lsr.l	d6,d5
	and.l	#$0000ffff,d5
	lsr.l	d4,d5

	move.b	d5,d6
	lsr.w	#8,d5

	not.b	d5
	not.b	d6

PlCl1:	movea.l	a0,a1
	add.l	d7,a0

	and.b	d5,(a1)+
	move.b	d2,d1
PlCl3:	tst.b	d1
	beq.s	PlCl2
	sf	(a1)+
	subq.b	#1,d1
	bne.s	PlCl3
PlCl2:	and.b	d6,(a1)+

	subq.w	#1,d3
	bne.s	PlCl1
	rts

*************************************************************************

;In:
;	a0.l - BitMap
;	a1.l - Mem
;	d0.w - x
;	d1.w - y
;	d2.w - dx
;	d3.w - dy
;	d4.b - plane num
Plane2Rect:
	ext.w	d4
	lsl.w	#2,d4
	move.l	bm_Planes(a0,d4.w),a2
	moveq	#0,d4
	move.w	bm_BPR(a0),d4
	mulu.w	d4,d1
	add.l	d1,a2
	add.w	d0,d2
	subq.w	#1,d2
	lsr.w	#3,d0
	lsr.w	#3,d2
	sub.w	d0,d2
	ext.l	d0
	ext.l	d2
	add.l	d0,a2

	move.l	a2,a3
	add.l	d4,a2
	move.w	d2,d5
	subq.w	#1,d3

PlRe1:	move.b	(a3)+,(a1)+
	dbf	d5,PlRe1

	tst.w	d3
	beq.s	PlRe0

PlRe3:	cmp.w	#1,d3
	beq.s	PlRe2

	move.l	a2,a3
	add.l	d4,a2
	move.b	(a3),(a1)+
	add.l	d2,a3
	move.b	(a3),(a1)+

	subq.w	#1,d3
	bra.s	PlRe3

PlRe2:	move.b	(a2)+,(a1)+
	dbf	d2,PlRe2

PlRe0:	rts

*************************************************************************

;In:
;	a0.l - BitMap
;	a1.l - Mem
;	d0.w - x
;	d1.w - y
;	d2.w - dx
;	d3.w - dy
;	d4.b - plane num
Rect2Plane:
	ext.w	d4
	lsl.w	#2,d4
	move.l	bm_Planes(a0,d4.w),a2
	moveq	#0,d4
	move.w	bm_BPR(a0),d4
	mulu.w	d4,d1
	add.l	d1,a2
	add.w	d0,d2
	subq.w	#1,d2
	lsr.w	#3,d0
	lsr.w	#3,d2
	sub.w	d0,d2
	ext.l	d0
	ext.l	d2
	add.l	d0,a2

	move.l	a2,a3
	add.l	d4,a2
	move.w	d2,d5
	subq.w	#1,d3

PlRc1:	move.b	(a1)+,(a3)+
	dbf	d5,PlRc1

	tst.w	d3
	beq.s	PlRc0

PlRc3:	cmp.w	#1,d3
	beq.s	PlRc2

	move.l	a2,a3
	add.l	d4,a2
	move.b	(a1)+,(a3)
	add.l	d2,a3
	move.b	(a1)+,(a3)

	subq.w	#1,d3
	bra.s	PlRc3

PlRc2:	move.b	(a1)+,(a2)+
	dbf	d2,PlRc2

PlRc0:	rts

*************************************************************************

;In:
;	a0.l - scr BitMap
;	a1.l - dst BitMap
;	d0.w - src x
;	d1.w - src y
;	d2.w - dst x
;	d3.w - dst y
;	d4.w - dx
;	d5.w - dy
;	d6.b - src plane num
;	d7.b - dst plane num
PlaneCopy:
	ext.w	d6
	ext.w	d7
	lsl.w	#2,d6
	lsl.w	#2,d7
	move.l	bm_Planes(a0,d6.w),a2
	move.l	bm_Planes(a1,d7.w),a3
	move.l	bm_Mask(a0),a4
	mulu.w	bm_BPR(a0),d1
	mulu.w	bm_BPR(a1),d3
	add.l	d1,a2
	add.l	d3,a3
	ext.l	d0
	ext.l	d2
	ext.l	d4
	ext.l	d5
	move.l	d0,d1
	move.l	d2,d3
	lsr.w	#3,d0
	lsr.w	#3,d2
	add.l	d0,a2
	add.l	d2,a3
	and.w	#7,d1
	and.w	#7,d3

	;wyczyszczenie maski zrodla

	lea	Copy1Mem,a6
	move.w	#161,d7
PlCo3:	sf	(a6)+
	dbf	d7,PlCo3

	;zrobienie maski dla zrodla

	move.w	d4,d7
	moveq	#7,d6
	lea	Copy1Mem,a6
PlCo2:	bset	d6,(a6)
	subq.b	#1,d6
	bpl.s	PlCo4
	moveq	#7,d6
	lea	1(a6),a6
PlCo4:	subq.w	#1,d7
	bne.s	PlCo2

	;przesuniecie maski zrodla

	lsr.w	#3,d4
	addq.w	#2,d4

	move.w	d4,-(sp)
	lea	Copy1Mem,a5
	lea	Copy3Mem,a6
	moveq	#0,d0
PlCo20:	moveq	#0,d6
	move.b	(a5)+,d6
	ror.w	d3,d6
	or.w	d0,d6
	move.b	d6,(a6)+
	not.b	-1(a6)
	move.w	d6,d0
	lsr.w	#8,d0
	subq.w	#1,d4
	bne.s	PlCo20
	move.w	(sp)+,d4

PlCoLoop:

	; source do bufora 2

	lea	Copy2Mem,a6
	movem.l	d4/a2,-(sp)
	move.w	bm_BPR(a0),d4
PlCp1:	move.b	(a2)+,(a6)+
	subq.w	#1,d4
	bne.s	PlCp1
	movem.l	(sp)+,d4/a2

	; scroll source w 2 do zera

	move.w	d4,-(sp)
	lea	Copy2Mem,a6
	move.b	(a6),d7
	lsl.b	d1,d7
	move.b	d7,(a6)+
PlCp4:	subq.w	#1,d4
	beq.s	PlCp3
	moveq	#0,d7
	move.b	(a6),d7
	lsl.w	d1,d7
	move.b	d7,(a6)+
	lsr.w	#8,d7
	or.b	d7,-2(a6)
	bra.w	PlCp4
PlCp3:	move.w	(sp)+,d4

	;source AND maska i scroll w prawo na pozycje

	move.w	d4,-(sp)
	lea	Copy1Mem,a5
	lea	Copy2Mem,a6
	moveq	#0,d0
PlCp2:	moveq	#0,d6
	move.b	(a6),d6
	and.b	(a5)+,d6
	ror.w	d3,d6
	or.w	d0,d6
	move.b	d6,(a6)+
	move.w	d6,d0
	lsr.w	#8,d0
	subq.w	#1,d4
	bne.s	PlCp2
	move.w	(sp)+,d4

	;maska obrazka

	btst	#0,bm_Flags(a0)
	beq.s	PlCp40
	move.w	d4,-(sp)
	move.w	bm_BPR(a0),d4
	lea	Copy1Mem,a6
	lea	Copy3Mem,a5
	moveq	#0,d0
PlCp41:	moveq	#0,d6
	move.b	(a4)+,d6
	and.b	(a6)+,d6
	ror.w	d3,d6
	or.w	d0,d6
	move.b	d6,(a5)+
	not.b	-1(a5)
	move.w	d6,d0
	lsr.w	#8,d0
	subq.w	#1,d4
	bne.s	PlCp41
	move.w	(sp)+,d4
PlCp40:	moveq	#0,d6
	ror.w	d3,d6
	or.w	d0,d6
	move.b	d6,(a5)+
	not.b	-1(a5)

	;dest AND maska i OR source

	movem.l	d4/a3,-(sp)
	lea	Copy2Mem,a5
	lea	Copy3Mem,a6
PlCp10:	move.b	(a3),d0
	and.b	(a6)+,d0
	or.b	(a5)+,d0
	move.b	d0,(a3)+
	subq.w	#1,d4
	bne.s	PlCp10
	movem.l	(sp)+,d4/a3

	moveq	#0,d7
	move.w	bm_BPR(a0),d7
	add.l	d7,a2
	move.w	bm_BPR(a1),d7
	add.l	d7,a3
	subq.w	#1,d5
	bne.w	PlCoLoop
	rts

*************************************************************************
*************************************************************************

;In:
;	a0.l - BitMap
;	d0.w - x
;	d1.w - y
;	d2.b - kolor
_PutPixel:
	move.b	d2,d3
	moveq	#0,d2
PuPi3:	movem.l	d0-d3/a0,-(sp)
	btst	d2,d3
	bne.s	PuPi1
	bsr.w	ClrPixel
	bra.s	PuPi2
PuPi1:	bsr.w	SetPixel
PuPi2:	movem.l	(sp)+,d0-d3/a0
	addq.b	#1,d2
	cmp.b	bm_Depth(a0),d2
	bne.s	PuPi3
	rts

*************************************************************************

;In:
;	a0.l - BitMap
;	d0.w - x
;	d1.w - y
;	d2.w - dx
;	d3.b - kolor
_LineH:
	exg	d2,d3
LiNh1:	movem.l	d0-d3/a0,-(sp)
	bsr.s	_PutPixel
	movem.l	(sp)+,d0-d3/a0
	addq.w	#1,d0
	subq.w	#1,d3
	bne.s	LiNh1
	rts

*************************************************************************

;In:
;	a0.l - BitMap
;	d0.w - x
;	d1.w - y
;	d2.w - dy
;	d3.b - kolor
_LineV:
	exg	d2,d3
LiNv1:	movem.l	d0-d3/a0,-(sp)
	bsr.s	_PutPixel
	movem.l	(sp)+,d0-d3/a0
	addq.w	#1,d1
	subq.w	#1,d3
	bne.s	LiNv1
	rts

*************************************************************************

;In:
;	a0.l - BitMap
;	d0.w - x
;	d1.w - y
;	d2.w - dx
_LineHEOR:
	exg	d2,d3
LiNh1E:	movem.l	d0-d3/a0,-(sp)
	moveq	#2,d2
	bsr.w	ChgPixel
	movem.l	(sp)+,d0-d3/a0
	addq.w	#1,d0
	subq.w	#1,d3
	bne.s	LiNh1E
	rts

*************************************************************************

;In:
;	a0.l - BitMap
;	d0.w - x
;	d1.w - y
;	d2.w - dy
_LineVEOR:
	exg	d2,d3
LiNv1E:	movem.l	d0-d3/a0,-(sp)
	moveq	#2,d2
	bsr.w	ChgPixel
	movem.l	(sp)+,d0-d3/a0
	addq.w	#1,d1
	subq.w	#1,d3
	bne.s	LiNv1E
	rts

*************************************************************************

;In:
;	a0.l - BitMap
;	d0.w - x
;	d1.w - y
;	d2.w - dx
;	d3.w - dy
;	d4.b - kolor
_Rectangle:
	exg	d3,d4
	movem.l	d0-d4/a0,-(sp)
	bsr.s	_LineH
	movem.l	(sp)+,d0-d4/a0
	movem.l	d0-d4/a0,-(sp)
	exg	d4,d2
	bsr.s	_LineV
	movem.l	(sp)+,d0-d4/a0
	movem.l	d0-d4/a0,-(sp)
	exg	d4,d2
	add.w	d4,d0
	subq.w	#1,d0
	bsr.s	_LineV
	movem.l	(sp)+,d0-d4/a0
	add.w	d4,d1
	subq.w	#1,d1
	movem.l	d0-d4/a0,-(sp)
	bsr.w	_LineH
	movem.l	(sp)+,d0-d4/a0
	rts

*************************************************************************

;In:
;	a0.l - BitMap
;	d0.w - x
;	d1.w - y
;	d2.w - dx
;	d3.w - dy
_RectEOR:
	exg	d3,d4
	movem.l	d0-d4/a0,-(sp)
	bsr.s	_LineHEOR
	movem.l	(sp)+,d0-d4/a0
	movem.l	d0-d4/a0,-(sp)
	exg	d4,d2
	bsr.s	_LineVEOR
	movem.l	(sp)+,d0-d4/a0
	movem.l	d0-d4/a0,-(sp)
	exg	d4,d2
	add.w	d4,d0
	subq.w	#1,d0
	bsr.s	_LineVEOR
	movem.l	(sp)+,d0-d4/a0
	add.w	d4,d1
	subq.w	#1,d1
	movem.l	d0-d4/a0,-(sp)
	bsr.w	_LineHEOR
	movem.l	(sp)+,d0-d4/a0
	rts

*************************************************************************

;In:
;	a0.l - BitMap
;	d0.w - x
;	d1.w - y
;	d2.w - dx
;	d3.w - dy
;	d4.b - kolor
_RectFill:
	moveq	#0,d5
	exg	d4,d5
ReFi3:	movem.l	d0-d5/a0,-(sp)
	btst	d4,d5
	bne.s	ReFi1
	bsr.w	PlaneClr
	bra.s	ReFi2
ReFi1:	bsr.w	PlaneSet
ReFi2:	movem.l	(sp)+,d0-d5/a0
	addq.b	#1,d4
	cmp.b	bm_Depth(a0),d4
	bne.s	ReFi3
	rts

*************************************************************************

;In:
;	a0.l - BitMap
;	d0.w - x
;	d1.w - y
;	d2.w - dx
;	d3.w - dy
;	d4.b - kolor up
;	d5.b - kolor down
_Box3D:
	movem.l	d0-d5/a0,-(sp)
	exg	d4,d3
	bsr.w	_LineH
	movem.l	(sp)+,d0-d5/a0
	movem.l	d0-d5/a0,-(sp)
	exg	d3,d2
	exg	d4,d3
	bsr.w	_LineV
	movem.l	(sp)+,d0-d5/a0
	movem.l	d0-d5/a0,-(sp)
	exg	d5,d3
	add.w	d5,d1
	addq.w	#1,d0
	subq.w	#1,d1
	subq.w	#1,d2
	bsr.w	_LineH
	movem.l	(sp)+,d0-d5/a0
	movem.l	d0-d5/a0,-(sp)
	add.w	d2,d0
	subq.w	#1,d0
	addq.w	#1,d1
	move.w	d3,d2
	subq.w	#1,d2
	move.w	d5,d3
	bsr.w	_LineV
	movem.l	(sp)+,d0-d5/a0
	rts

*************************************************************************

;In:
;	a0.l - BitMap
;	d0.w - x
;	d1.w - y
;	d2.w - dx
;	d3.w - dy
;	d4.b - kolor up
;	d5.b - kolor mid
;	d6.b - kolor down
_Bar3D:
	move.w	d5,-(sp)
	exg	d5,d6
	bsr.s	_Box3D
	addq.w	#1,d0
	addq.w	#1,d1
	subq.w	#2,d2
	subq.w	#2,d3
	move.w	(sp)+,d4
	bsr.w	_RectFill
	rts

*************************************************************************

;In:
;	a0.l - scr BitMap
;	a1.l - dst BitMap
;	d0.w - src x
;	d1.w - src y
;	d2.w - dst x
;	d3.w - dst y
;	d4.w - dx
;	d5.w - dy
_BitMapCopy:
	moveq	#0,d6
	moveq	#0,d7
BmCo1:	movem.l	d0-d7/a0-a1,-(sp)
	bsr.w	PlaneCopy
	movem.l	(sp)+,d0-d7/a0-a1
	addq.b	#1,d6
	addq.b	#1,d7
	cmp.b	bm_Depth(a0),d6
	beq.s	BmCo0
	cmp.b	bm_Depth(a1),d6
	bne.s	BmCo1
BmCo0:	rts

*************************************************************************
*************************************************************************

;In:
;	a0.l - window
ResetMinMax:
	move.w	#$7fff,wi_MinX(a0)
	move.w	#$7fff,wi_MinY(a0)
	move.w	#-1,wi_MaxX(a0)
	move.w	#-1,wi_MaxY(a0)
	rts

*************************************************************************

;In:
;	a0.l - window
;	d0.w - x
;	d1.w - y
;	d2.b - kolor
PutPixel:
	btst	#1,wi_BitMap+bm_Flags(a0)
	bne.s	PuPp1
	bsr.s	ResetMinMax
PuPp1:	move.l	a0,-(sp)
	bsr.s	__PutPixel
	move.l	(sp)+,a0
	btst	#1,wi_BitMap+bm_Flags(a0)
	bne.s	PuPp0
	bra.w	RegionRedraw
PuPp0:	rts

__PutPixel:
	cmp.w	wi_ClipMinX(a0),d0
	blt.s	PuPi0
	cmp.w	wi_ClipMinY(a0),d1
	blt.s	PuPi0
	cmp.w	wi_ClipMaxX(a0),d0
	bgt.s	PuPi0
	cmp.w	wi_ClipMaxY(a0),d1
	bgt.s	PuPi0
	cmp.w	wi_MinX(a0),d0
	bge.s	PuPp2
	move.w	d0,wi_MinX(a0)
PuPp2:	cmp.w	wi_MinY(a0),d1
	bge.s	PuPp3
	move.w	d1,wi_MinY(a0)
PuPp3:	cmp.w	wi_MaxX(a0),d0
	ble.s	PuPp4
	move.w	d0,wi_MaxX(a0)
PuPp4:	cmp.w	wi_MaxY(a0),d1
	ble.s	PuPp5
	move.w	d1,wi_MaxY(a0)
PuPp5:	lea	wi_BitMap(a0),a0
	bsr.w	_PutPixel
PuPi0:	rts

*************************************************************************

;In:
;	a0.l - window
;	d0.w - x
;	d1.w - y
;	d2.w - dx
;	d3.b - kolor
LineH:
	btst	#1,wi_BitMap+bm_Flags(a0)
	bne.s	LiEh1
	bsr.w	ResetMinMax
LiEh1:	bsr.s	__LineH
	btst	#1,wi_BitMap+bm_Flags(a0)
	bne.s	LiEh2
	bra.w	RegionRedraw
LiEh2:	rts

__LineH:
	exg	d2,d3
LiEh01:	tst.w	d3
	beq.s	LiEh0
	movem.l	d0-d3/a0,-(sp)
	bsr.s	__PutPixel
	movem.l	(sp)+,d0-d3/a0
	addq.w	#1,d0
	subq.w	#1,d3
	bra.s	LiEh01
LiEh0:	rts

*************************************************************************

;In:
;	a0.l - window
;	d0.w - x
;	d1.w - y
;	d2.w - dy
;	d3.b - kolor
LineV:
	btst	#1,wi_BitMap+bm_Flags(a0)
	bne.s	LiEv1
	bsr.w	ResetMinMax
LiEv1:	bsr.s	__LineV
	btst	#1,wi_BitMap+bm_Flags(a0)
	bne.s	LiEv2
	bra.w	RegionRedraw
LiEv2:	rts

__LineV:
	exg	d2,d3
LiEv01:	tst.w	d3
	beq.s	LiEv0
	movem.l	d0-d3/a0,-(sp)
	bsr.w	__PutPixel
	movem.l	(sp)+,d0-d3/a0
	addq.w	#1,d1
	subq.w	#1,d3
	bra.s	LiEv01
LiEv0:	rts

*************************************************************************

;In:
;	a0.l - window
;	d0.w - x
;	d1.w - y
;	d2.w - dx
;	d3.w - dy
;	d4.b - kolor
Rectangle:
	btst	#1,wi_BitMap+bm_Flags(a0)
	bne.s	ReCt1
	bsr.w	ResetMinMax
ReCt1:	bsr.s	__Rectangle
	btst	#1,wi_BitMap+bm_Flags(a0)
	bne.s	ReCt2
	bra.w	RegionRedraw
ReCt2:	rts

__Rectangle:
	exg	d3,d4
	movem.l	d0-d4/a0,-(sp)
	bsr.s	__LineH
	movem.l	(sp)+,d0-d4/a0
	movem.l	d0-d4/a0,-(sp)
	exg	d4,d2
	bsr.s	__LineV
	movem.l	(sp)+,d0-d4/a0
	movem.l	d0-d4/a0,-(sp)
	exg	d4,d2
	add.w	d4,d0
	subq.w	#1,d0
	bsr.s	__LineV
	movem.l	(sp)+,d0-d4/a0
	add.w	d4,d1
	subq.w	#1,d1
	movem.l	d0-d4/a0,-(sp)
	bsr.w	__LineH
	movem.l	(sp)+,d0-d4/a0
	rts

*************************************************************************

;In:
;	d0.w - x
;	d1.w - y
;	d2.w - dx
;	d3.w - dy
;Out:
;	d7.b - T/F
CheckRange:
	add.w	d0,d2
	add.w	d1,d3
	subq.w	#1,d2
	subq.w	#1,d3
	cmp.w	wi_ClipMaxX(a0),d0
	bgt.s	ReTi0
	cmp.w	wi_ClipMaxY(a0),d1
	bgt.s	ReTi0
	cmp.w	wi_ClipMinX(a0),d2
	blt.s	ReTi0
	cmp.w	wi_ClipMinY(a0),d3
	blt.s	ReTi0
	cmp.w	wi_ClipMinX(a0),d0
	bge.s	ReTi1
	move.w	wi_ClipMinX(a0),d0
ReTi1:	cmp.w	wi_ClipMinY(a0),d1
	bge.s	ReTi2
	move.w	wi_ClipMinY(a0),d1
ReTi2:	cmp.w	wi_ClipMaxX(a0),d2
	ble.s	ReTi3
	move.w	wi_ClipMaxX(a0),d2
ReTi3:	cmp.w	wi_ClipMaxY(a0),d3
	ble.s	ReTi4
	move.w	wi_ClipMaxY(a0),d3
ReTi4:
	cmp.w	wi_MinX(a0),d0
	bge.s	ReTi10
	move.w	d0,wi_MinX(a0)
ReTi10:	cmp.w	wi_MinY(a0),d1
	bge.s	ReTi11
	move.w	d1,wi_MinY(a0)
ReTi11:	cmp.w	wi_MaxX(a0),d2
	ble.s	ReTi12
	move.w	d2,wi_MaxX(a0)
ReTi12:	cmp.w	wi_MaxY(a0),d3
	ble.s	ReTi13
	move.w	d3,wi_MaxY(a0)
ReTi13:

	sub.w	d0,d2
	sub.w	d1,d3
	addq.w	#1,d2
	addq.w	#1,d3
	st	d7
	rts
ReTi0:	sf	d7
	rts

*************************************************************************

;In:
;	a0.l - window
;	d0.w - x
;	d1.w - y
;	d2.w - dx
;	d3.w - dy
;	d4.b - kolor
RectFill:
	btst	#1,wi_BitMap+bm_Flags(a0)
	bne.s	ReFl1
	bsr.w	ResetMinMax
ReFl1:	move.l	a0,-(sp)
	bsr.s	__RectFill
	move.l	(sp)+,a0
	btst	#1,wi_BitMap+bm_Flags(a0)
	bne.s	ReFl2
	bra.w	RegionRedraw
ReFl2:	rts

__RectFill:
	bsr.w	CheckRange
	beq.s	RcFi0
	lea	wi_BitMap(a0),a0
	bsr.w	_RectFill
RcFi0:	rts

*************************************************************************

;In:
;	a0.l - BitMap
;	d0.w - x
;	d1.w - y
;	d2.w - dx
;	d3.w - dy
;	d4.b - kolor up
;	d5.b - kolor down
Box3D:
	btst	#1,wi_BitMap+bm_Flags(a0)
	bne.s	Box31
	bsr.w	ResetMinMax
Box31:	bsr.s	__Box3D
	btst	#1,wi_BitMap+bm_Flags(a0)
	bne.s	Box32
	bra.w	RegionRedraw
Box32:	rts

__Box3D:
	movem.l	d0-d5/a0,-(sp)
	exg	d4,d3
	bsr.w	__LineH
	movem.l	(sp)+,d0-d5/a0
	movem.l	d0-d5/a0,-(sp)
	exg	d3,d2
	exg	d4,d3
	bsr.w	__LineV
	movem.l	(sp)+,d0-d5/a0
	movem.l	d0-d5/a0,-(sp)
	exg	d5,d3
	add.w	d5,d1
	addq.w	#1,d0
	subq.w	#1,d1
	subq.w	#1,d2
	bsr.w	__LineH
	movem.l	(sp)+,d0-d5/a0
	movem.l	d0-d5/a0,-(sp)
	add.w	d2,d0
	subq.w	#1,d0
	addq.w	#1,d1
	move.w	d3,d2
	subq.w	#1,d2
	move.w	d5,d3
	bsr.w	__LineV
	movem.l	(sp)+,d0-d5/a0
	rts

*************************************************************************

;In:
;	a0.l - BitMap
;	d0.w - x
;	d1.w - y
;	d2.w - dx
;	d3.w - dy
;	d4.b - kolor up
;	d5.b - kolor mid
;	d6.b - kolor down
Bar3D:
	btst	#1,wi_BitMap+bm_Flags(a0)
	bne.s	Bar31
	bsr.w	ResetMinMax
Bar31:	move.l	a0,-(sp)
	bsr.s	__Bar3D
	move.l	(sp)+,a0
	btst	#1,wi_BitMap+bm_Flags(a0)
	bne.s	Bar32
	bra.w	RegionRedraw
Bar32:	rts

__Bar3D:
	move.w	d5,-(sp)
	exg	d5,d6
	bsr.s	__Box3D
	addq.w	#1,d0
	addq.w	#1,d1
	subq.w	#2,d2
	subq.w	#2,d3
	move.w	(sp)+,d4
	bsr.w	__RectFill
	rts

*************************************************************************

;In:
;	a0.l - window
;	a1.l - image
;	d0.w - src x
;	d1.w - src y
;	d2.w - dst x
;	d3.w - dst y
;	d4.w - dx
;	d5.w - dy
BitMapCopy:
	btst	#1,wi_BitMap+bm_Flags(a0)
	bne.s	BitM1
	bsr.w	ResetMinMax
BitM1:	move.l	a0,-(sp)
	bsr.s	__BitMapCopy
	move.l	(sp)+,a0
	btst	#1,wi_BitMap+bm_Flags(a0)
	bne.s	BitM2
	bra.w	RegionRedraw
BitM2:	rts

__BitMapCopy:
	move.w	d2,_bm_x
	move.w	d3,_bm_y
	exg	d0,d2
	exg	d1,d3
	exg	d2,d4
	exg	d3,d5
	bsr.w	CheckRange
	tst.b	d7
	beq.s	BitM3

	move.w	d0,d6
	move.w	d1,d7
	sub.w	_bm_x,d6
	sub.w	_bm_y,d7

	move.w	d2,d4
	move.w	d3,d5
	move.w	d0,d2
	move.w	d1,d3
	move.w	d6,d0
	move.w	d7,d1

	lea	wi_BitMap(a0),a0
	exg	a0,a1
	bsr.w	_BitMapCopy
BitM3:	rts

*************************************************************************

;In:
;	a0.l - window
;	a1.l - tekst,0
;	d0.w - x
;	d1.w - y
;	d2.b - kolor
PutText:
	moveq	#0,d4
	move.l	_fonts_data,a6
	move.b	(a6),d4
	move.b	d2,d3
PuTe2:	move.b	(a1)+,d2
	bne.s	PuTe1
	rts
PuTe1:	movem.l	d0-d4/a0-a1,-(sp)
	bsr.s	PutFont
	movem.l	(sp)+,d0-d4/a0-a1
	add.w	d4,d0
	bra.s	PuTe2

*************************************************************************

;In:
;	a0.l - window
;	a1.l - tekst,0
;	d0.w - x
;	d1.w - y
;	d2.b - kolor
_PutText:
	moveq	#0,d4
	move.l	_fonts_data,a6
	move.b	(a6),d4
	move.b	d2,d3
PuT2:	move.b	(a1)+,d2
	bne.s	PuT1
	rts
PuT1:	movem.l	d0-d4/a0-a1,-(sp)
	bsr.s	_PutFont
	movem.l	(sp)+,d0-d4/a0-a1
	add.w	d4,d0
	bra.s	PuT2

*************************************************************************

;In:
;	a0.l - window
;	d0.w - x
;	d1.w - y
;	d2.b - kod
;	d3.b - kolor
PutFont:
	bsr.s	__PutFont
	bsr.w	BitMapCopy
	rts

;In:
;	a0.l - bitmap
;	d0.w - x
;	d1.w - y
;	d2.b - kod
;	d3.b - kolor
_PutFont:
	bsr.s	__PutFont
	exg	a0,a1
	bsr.w	_BitMapCopy
	rts

__PutFont:
	moveq	#0,d5
	move.l	_fonts_data,a6
	move.b	1(a6),d5
	and.l	#$ff,d2
	mulu.w	d5,d2
	lea	2(a6),a1
	adda.l	d2,a1
	moveq	#0,d5
	move.l	_fonts_bitmap,a2
	move.l	a1,bm_Mask(a2)
	lea	bm_Planes(a2),a2
	lea	_font_clr,a3
PuFo1:	move.l	a3,(a2)+
	btst	d5,d3
	beq.s	PuFo2
	move.l	a1,-4(a2)
PuFo2:	addq.b	#1,d5
	cmp.b	ScrBitMap+bm_Depth,d5
	bne.s	PuFo1
	move.l	_fonts_bitmap,a1
	move.w	d0,d2
	move.w	d1,d3
	moveq	#0,d0
	moveq	#0,d1
	moveq	#0,d4
	moveq	#0,d5
	move.l	_fonts_data,a6
	move.b	(a6),d4
	move.b	1(a6),d5
	rts

*************************************************************************
*************************************************************************

;In:
;	a0.l - window
RegionRedraw:
	cmp.w	#$7fff,wi_MinX(a0)
	beq.w	ReRe0

	move.w	wi_MinX(a0),d0
	cmp.w	wi_Width(a0),d0
	bge.s	ReRe0
	move.w	wi_MinY(a0),d1
	cmp.w	wi_Height(a0),d1
	bge.s	ReRe0
	move.w	wi_MaxX(a0),d2
	bmi.s	ReRe0
	move.w	wi_MaxY(a0),d3
	bmi.s	ReRe0
	add.w	wi_LeftEdge(a0),d0
	add.w	wi_TopEdge(a0),d1
	add.w	wi_LeftEdge(a0),d2
	add.w	wi_TopEdge(a0),d3

	;czy cale zakryte
	nop

	move.l	wi_Next(a0),a1
ReRe1:	cmpa.l	#0,a1
	beq.s	ReRe2
	move.l	wi_Next(a1),a1
	bra.s	ReRe1
ReRe2:

	move.w	wi_MinX(a0),d0
	move.w	wi_MinY(a0),d1
	move.w	wi_LeftEdge(a0),d2
	move.w	wi_TopEdge(a0),d3
	add.w	d0,d2
	add.w	d1,d3
	move.w	wi_MaxX(a0),d4
	move.w	wi_MaxY(a0),d5
	sub.w	d0,d4
	sub.w	d1,d5
	addq.w	#1,d4
	addq.w	#1,d5
	movem.l	d2-d5/a0,-(sp)
	lea	wi_BitMap(a0),a0
	lea	ScrBitMap,a1
	bsr	_BitMapCopy
	movem.l	(sp)+,d0-d3/a0

	move.l	wi_Next(a0),a0
	bra.s	ReRfX

ReRe0:	rts

*************************************************************************

;In:
;	d0.w - xp
;	d1.w - yp
;	d2.w - dx
;	d3.w - dy
RegionRefresh:
	movem.w	d0-d3,-(sp)
	lea	ScrBitMap,a0
	moveq	#BDColor,d4
	bsr.w	_RectFill
	movem.w	(sp)+,d0-d3
	move.l	WinList,a0
ReRfX:	add.w	d0,d2
	add.w	d1,d3
	subq.w	#1,d2
	subq.w	#1,d3
ReRf1:	cmpa.l	#0,a0
	beq.w	ReRf0
	move.w	wi_LeftEdge(a0),d4
	move.w	wi_TopEdge(a0),d5
	cmp.w	d4,d2
	blt.s	ReRf2
	cmp.w	d5,d3
	blt.s	ReRf2
	add.w	wi_Width(a0),d4
	add.w	wi_Height(a0),d5
	subq.w	#1,d4
	subq.w	#1,d5
	cmp.w	d4,d0
	bgt.s	ReRf2
	cmp.w	d5,d1
	bgt.s	ReRf2
	movem.l	d0-d3/a0,-(sp)
	move.w	d0,d6
	sub.w	wi_LeftEdge(a0),d6
	move.w	d1,d7
	sub.w	wi_TopEdge(a0),d7
	cmp.w	wi_LeftEdge(a0),d0
	bge.s	ReRf10
	moveq	#0,d6
	move.w	wi_LeftEdge(a0),d0
ReRf10:	cmp.w	wi_TopEdge(a0),d1
	bge.s	ReRf11
	moveq	#0,d7
	move.w	wi_TopEdge(a0),d1
ReRf11:	cmp.w	d4,d2
	ble.s	ReRf12
	move.w	d4,d2
ReRf12:	cmp.w	d5,d3
	ble.s	ReRf13
	move.w	d5,d3
ReRf13:	sub.w	d0,d2
	sub.w	d1,d3
	addq.w	#1,d2
	addq.w	#1,d3
	exg	d0,d2
	exg	d1,d3
	exg	d0,d4
	exg	d1,d5
	exg	d6,d0
	exg	d7,d1
	lea	wi_BitMap(a0),a0
	lea	ScrBitMap,a1
	bsr.w	_BitMapCopy
	movem.l	(sp)+,d0-d3/a0
ReRf2:	move.l	wi_Next(a0),a0
	bra.w	ReRf1
ReRf0:	rts

*************************************************************************

;In:
;	a0.l - window
ClipRegMem:
	move.w	wi_ClipMinX(a0),_clip_minx
	move.w	wi_ClipMinY(a0),_clip_miny
	move.w	wi_ClipMaxX(a0),_clip_maxx
	move.w	wi_ClipMaxY(a0),_clip_maxy
	clr.w	wi_ClipMinX(a0)
	clr.w	wi_ClipMinY(a0)
	move.w	wi_Width(a0),wi_ClipMaxX(a0)
	move.w	wi_Height(a0),wi_ClipMaxY(a0)
	sub.w	#1,wi_ClipMaxX(a0)
	sub.w	#1,wi_ClipMaxY(a0)
	bra	WindowLock

*************************************************************************

;In:
;	a0.l - window
ClipRegRes:
	move.w	_clip_minx,wi_ClipMinX(a0)
	move.w	_clip_miny,wi_ClipMinY(a0)
	move.w	_clip_maxx,wi_ClipMaxX(a0)
	move.w	_clip_maxy,wi_ClipMaxY(a0)
	bra	WindowUnLock

*************************************************************************

;In:
;	a0.l - window
;	a1.l - name
WindowName:
	move.l	a1,wi_Name(a0)
	btst	#0,wi_Flags+1(a0)
	bne.s	WiNa0
	move.l	a0,__win
	bsr	ClipRegMem
	move.l	__win,a0
	bsr.s	__WindowName
	move.l	__win,a0
	bsr	ClipRegRes
WiNa0:	rts

__WindowName:
	moveq	#2,d0
	moveq	#2,d1
	move.w	wi_Width(a0),d2
	subq.w	#4,d2
	moveq	#0,d3
	move.l	_fonts_data,a6
	move.b	1(a6),d3
	addq.w	#2,d3
	moveq	#6,d4
	btst	#1,wi_Flags+1(a0)
	bne.s	WiNa1
	moveq	#1,d4
WiNa1:	move.l	a0,-(sp)
	bsr.w	RectFill
	move.l	(sp)+,a0
	tst.l	wi_Name(a0)
	beq.s	WiNa2
	move.l	wi_Name(a0),a1
	moveq	#3,d0
	moveq	#3,d1
	moveq	#4,d2
	bsr.w	PutText
WiNa2:	rts

*************************************************************************

;In:
;	a0.l - window
GfxList:
	tst.l	wi_GfxList(a0)
	beq.s	GfLi0
	move.l	wi_GfxList(a0),a1
GL_Loop:
	move.b	(a1)+,d7
	cmp.b	#gl_LINEH,d7
	beq.s	_GL_LineH
	cmp.b	#gl_LINEV,d7
	beq.s	_GL_LineV
	cmp.b	#gl_BOX,d7
	beq.s	_GL_Box
	cmp.b	#gl_BAR,d7
	beq.s	_GL_Bar
	cmp.b	#gl_BOX3D,d7
	beq.s	_GL_Box3D
	cmp.b	#gl_BAR3D,d7
	beq.w	_GL_Bar3D
	cmp.b	#gl_TEXT,d7
	beq.w	_GL_Text
	cmp.b	#gl_IMAGE,d7
	beq.w	_GL_Image
GfLi0:	rts

_GL_LineH:
	move.b	(a1)+,d3
	move.w	(a1)+,d0
	move.w	(a1)+,d1
	move.w	(a1)+,d2
	movem.l	a0-a1,-(sp)
	bsr.w	__LineH
	movem.l	(sp)+,a0-a1
	bra.s	GL_Loop
_GL_LineV:
	move.b	(a1)+,d3
	move.w	(a1)+,d0
	move.w	(a1)+,d1
	move.w	(a1)+,d2
	movem.l	a0-a1,-(sp)
	bsr.w	__LineV
	movem.l	(sp)+,a0-a1
	bra.s	GL_Loop
_GL_Box:
	move.b	(a1)+,d4
	move.w	(a1)+,d0
	move.w	(a1)+,d1
	move.w	(a1)+,d2
	move.w	(a1)+,d3
	movem.l	a0-a1,-(sp)
	bsr.w	__Rectangle
	movem.l	(sp)+,a0-a1
	bra.s	GL_Loop
_GL_Bar:
	move.b	(a1)+,d4
	move.w	(a1)+,d0
	move.w	(a1)+,d1
	move.w	(a1)+,d2
	move.w	(a1)+,d3
	movem.l	a0-a1,-(sp)
	bsr.w	__RectFill
	movem.l	(sp)+,a0-a1
	bra.w	GL_Loop
_GL_Box3D:
	move.b	(a1)+,d4
	move.b	(a1)+,d5
	move.b	(a1)+,d6
	move.w	(a1)+,d0
	move.w	(a1)+,d1
	move.w	(a1)+,d2
	move.w	(a1)+,d3
	movem.l	a0-a1,-(sp)
	bsr.w	__Box3D
	movem.l	(sp)+,a0-a1
	bra.w	GL_Loop
_GL_Bar3D:
	move.b	(a1)+,d4
	move.b	(a1)+,d5
	move.b	(a1)+,d6
	move.w	(a1)+,d0
	move.w	(a1)+,d1
	move.w	(a1)+,d2
	move.w	(a1)+,d3
	movem.l	a0-a1,-(sp)
	bsr.w	__Bar3D
	movem.l	(sp)+,a0-a1
	bra.w	GL_Loop
_GL_Text:
	move.b	(a1)+,d2
	move.w	(a1)+,d0
	move.w	(a1)+,d1
	move.l	(a1)+,a2
	movem.l	a0-a1,-(sp)
	move.l	a2,a1
	bsr.w	PutText
	movem.l	(sp)+,a0-a1
	bra.w	GL_Loop
_GL_Image:
	lea	1(a1),a1
	move.w	(a1)+,d2
	move.w	(a1)+,d3
	moveq	#0,d0
	moveq	#0,d1
	move.l	(a1)+,a2
	move.w	bm_Width(a2),d4
	move.w	bm_Height(a2),d5
	movem.l	a0-a1,-(sp)
	lea	wi_BitMap(a0),a1
	move.l	a2,a0
	bsr.w	_BitMapCopy
	movem.l	(sp)+,a0-a1
	bra.w	GL_Loop

*************************************************************************

;In:
;	a0.l - window
WindowDraw:
	btst	#0,wi_Flags+1(a0)
	bne.w	WiDr0
	move.l	a0,__win
	bsr	ClipRegMem
	move.l	__win,a0
	moveq	#0,d0
	moveq	#0,d1
	move.w	wi_Width(a0),d2
	move.w	wi_Height(a0),d3
	moveq	#4,d4
	moveq	#2,d5
	moveq	#0,d6
	bsr.w	Bar3D
	move.l	__win,a0
	bsr.w	__WindowName
	move.l	__win,a0
	tst.l	wi_Menu(a0)
	beq.s	WiDr1
	move.l	wi_Menu(a0),a2
WiDr2:	tst.l	(a2)
	beq.s	WiDr1
	move.l	(a2),a1
	move.w	8(a2),d0
	addq.w	#4,d0
	move.w	#13,d1
	moveq	#0,d2
	movem.l	a0/a2,-(sp)
	bsr.w	PutText
	movem.l	(sp)+,a0/a2
	lea	16(a2),a2
	bra.s	WiDr2
WiDr1:	move.l	__win,a0
	bsr.w	GfxList
	move.l	__win,a0
	bsr.w	_DrawGadgets
	move.l	__win,a0
	bsr.w	ClipRegRes
WiDr0:	rts

*************************************************************************

;In:
;	a0.l - new window
;Out:
;	d0.l - window
WindowOpen:
	move.l	a0,_new_window
	moveq	#WI_SIZE,d0
	bsr.w	AllocMem
	move.l	d0,_window
	beq	WiOp1

	move.w	#WI_SIZE-1,d0
WiOp2:	sf	(a0)+
	dbf	d0,WiOp2

	move.l	_window,a0
	lea	wi_BitMap(a0),a0
	move.l	a0,_bit_map

	move.l	_window,a0
	move.l	_new_window,a1
	move.l	nw_Name(a1),wi_Name(a0)
	move.l	nw_Menu(a1),wi_Menu(a0)
	move.l	nw_Gadgets(a1),wi_Gadgets(a0)
	move.l	nw_GfxList(a1),wi_GfxList(a0)
	move.w	nw_LeftEdge(a1),wi_LeftEdge(a0)
	move.w	nw_TopEdge(a1),wi_TopEdge(a0)
	move.w	nw_Width(a1),wi_Width(a0)
	move.w	nw_Height(a1),wi_Height(a0)
	move.w	nw_MinHeight(a1),wi_MinHeight(a0)
	move.w	nw_MinWidth(a1),wi_MinWidth(a0)
	move.w	nw_MaxHeight(a1),wi_MaxHeight(a0)
	move.w	nw_MaxWidth(a1),wi_MaxWidth(a0)
	move.w	nw_Flags(a1),wi_Flags(a0)

	move.l	_window,a0
	bsr.w	CalcMenu
	move.l	_window,a0
	bsr.w	RemoveClipRegion
	move.l	_window,a0
	bsr.w	ResetMinMax

	move.w	wi_Width(a0),wi_BitMap+bm_Width(a0)
	move.w	wi_Height(a0),wi_BitMap+bm_Height(a0)
	move.w	wi_Width(a0),d0
	move.w	d0,d1
	lsr.w	#3,d0
	and.b	#7,d1
	beq	WiOp3
	addq.w	#1,d0
WiOp3:	move.w	d0,wi_BitMap+bm_BPR(a0)
	move.b	ScrBitMap+bm_Depth,wi_BitMap+bm_Depth(a0)

	move.w	wi_BitMap+bm_BPR(a0),d0
	mulu.w	wi_BitMap+bm_Height(a0),d0
	move.l	d0,_plane_size

	lea	wi_BitMap+bm_Planes(a0),a1
	move.b	wi_BitMap+bm_Depth(a0),d1
WiOp4:	movem.l	d1/a1,-(sp)
	move.l	_plane_size,d0
	bsr.w	AllocMem
	movem.l	(sp)+,d1/a1
	move.l	d0,(a1)+
	beq.w	WiOpErr
	subq.b	#1,d1
	bne.s	WiOp4

	bsr.w	WindowUnActive

	lea	WinList,a0
WiOp7:	tst.l	(a0)
	beq.s	WiOp6
	move.l	(a0),a0
	bra.s	WiOp7
WiOp6:	move.l	_window,(a0)

	move.l	_window,a0
	bset	#1,wi_Flags+1(a0)
	bsr.w	WindowDraw

	move.l	_window,d0
	move.l	d0,ActWindow
WiOp1:	rts

WiOpErr:
	move.l	_window,a0
	lea	wi_BitMap+bm_Planes(a0),a0
	moveq	#7,d0
WOErr:	movem.l	d0/a0,-(sp)
	move.l	(a0),a0
	bsr.w	FreeMem
	movem.l	(sp)+,d0/a0
	lea	4(a0),a0
	dbf	d0,WOErr
	moveq	#0,d0
	rts

*************************************************************************

;In:
;	a0.l - window
WindowClose:
	move.l	a0,-(sp)
	lea	wi_BitMap+bm_Planes(a0),a0
	moveq	#7,d0
WiCl1:	movem.l	d0/a0,-(sp)
	move.l	(a0),a0
	bsr.w	FreeMem
	movem.l	(sp)+,d0/a0
	lea	4(a0),a0
	dbf	d0,WiCl1
	move.l	(sp)+,a0
	lea	WinList,a1
WiCl2:	cmp.l	(a1),a0
	beq.s	WiCl3
	move.l	(a1),a1
	bra.s	WiCl2
WiCl3:	move.l	(a0),(a1)
	move.l	a0,-(sp)
	move.w	wi_LeftEdge(a0),d0
	move.w	wi_TopEdge(a0),d1
	move.w	wi_Width(a0),d2
	move.w	wi_Height(a0),d3
	bsr.w	RegionRefresh
	move.l	(sp)+,a0
	cmp.l	ActWindow,a0
	bne.s	WiCl9
	move.l	a0,-(sp)
	clr.l	ActWindow
	bsr.s	WindowLastActive
	move.l	(sp)+,a0
WiCl9:	bsr.w	FreeMem
	rts

*************************************************************************

;In:
;	a0.l - window
WindowLock:
	bset	#1,wi_BitMap+bm_Flags(a0)
	bra.w	ResetMinMax

*************************************************************************

;In:
;	a0.l - window
WindowUnLock:
	bclr	#1,wi_BitMap+bm_Flags(a0)
	bra.w	RegionRedraw

*************************************************************************

;In:
;	a0.l - window
WindowActive:
	cmpa.l	#0,a0
	beq.s	WiAc0
	btst	#1,wi_Flags+1(a0)
	bne.s	WiAc0
	bsr.w	MouseOff
	move.l	a0,-(sp)
	bsr.s	WindowUnActive
	move.l	(sp)+,a0
	move.l	a0,ActWindow
	bsr.s	WindowToFront
	move.l	ActWindow,a0
	bset	#1,wi_Flags+1(a0)
	move.l	wi_Name(a0),a1
	bsr.w	WindowName
	bsr.w	MouseOn
WiAc0:	rts

*************************************************************************

WindowUnActive:
	tst.l	ActWindow
	beq.s	WiAu0
	move.l	ActWindow,a0
	bclr	#1,wi_Flags+1(a0)
	clr.l	ActWindow
	move.l	wi_Name(a0),a1
	bsr.w	WindowName
WiAu0:	rts

*************************************************************************

WindowLastActive:
	move.l	WinList,a0
	cmpa.l	#0,a0
	beq.s	WiLa0
WiLa1:	tst.l	wi_Next(a0)
	beq.s	WiLa0
	move.l	wi_Next(a0),a0
	bra.s	WiLa1
WiLa0:	bra	WindowActive

*************************************************************************

;In:
;	a0.l - window
WindowToFront:
	lea	WinList,a1
WiTf2:	cmp.l	(a1),a0
	beq.s	WiTf1
	move.l	wi_Next(a1),a1
	bra.s	WiTf2
WiTf1:	move.l	(a0),(a1)
	clr.l	(a0)
	lea	WinList,a1
WiTf3:	tst.l	(a1)
	beq.s	WiTf4
	move.l	wi_Next(a1),a1
	bra.s	WiTf3
WiTf4:	move.l	a0,(a1)
	moveq	#0,d0
	moveq	#0,d1
	move.w	wi_LeftEdge(a0),d2
	move.w	wi_TopEdge(a0),d3
	move.w	wi_Width(a0),d4
	move.w	wi_Height(a0),d5
	lea	wi_BitMap(a0),a0
	lea	ScrBitMap,a1
	bsr.w	_BitMapCopy
	rts

*************************************************************************

;In:
;	a0.l - window
;	d0.w - x
;	d1.w - y
;	d2.w - dx
;	d3.w - dy
InstallClipRegion:
	add.w	d0,d2
	add.w	d1,d3
	subq.w	#1,d2
	subq.w	#1,d3
	move.w	d0,wi_ClipMinX(a0)
	move.w	d1,wi_ClipMinY(a0)
	move.w	d2,wi_ClipMaxX(a0)
	move.w	d3,wi_ClipMaxY(a0)
	rts

*************************************************************************

;In:
;	a0.l - window
RemoveClipRegion:
	moveq	#0,d0
	moveq	#0,d1
	move.w	wi_Width(a0),d2
	move.w	wi_Height(a0),d3
	bra.s	InstallClipRegion

*************************************************************************

;In:
;	a0.l - window
;	d0.w - x
;	d1.w - y
WindowMove:
	bsr.w	MouseOff
	exg	d0,d4
	exg	d1,d5
	move.w	wi_LeftEdge(a0),d0
	move.w	wi_TopEdge(a0),d1
	move.w	wi_Width(a0),d2
	move.w	wi_Height(a0),d3
	move.w	d4,wi_LeftEdge(a0)
	move.w	d5,wi_TopEdge(a0)
	move.l	a0,-(sp)
	bsr.w	RegionRefresh
	move.l	(sp)+,a0
	bsr.w	WindowToFront
	bsr.s	MouseOn
	rts

*************************************************************************

;In:
;	a0.l - window
;	d0.w - width
;	d1.w - height
WindowReSize:
	bsr.w	MouseOff
	bsr.s	MouseOn
	rts

*************************************************************************

Backdrop:
	lea	ScrBitMap,a0
	moveq	#0,d0
	moveq	#0,d1
	move.w	#DefWidth,d2
	move.w	#DefHeight,d3
	moveq	#BDColor,d4
	bsr.w	_RectFill
	rts

*************************************************************************

CheckMouse:
	move.w	#MouseW,d4
	move.w	#MouseH,d5
	move.w	ScrBitMap+bm_Width,d6
	sub.w	d2,d6
	cmp.w	d6,d4
	ble.s	ChMo1
	move.w	d6,d4
ChMo1:	move.w	ScrBitMap+bm_Height,d7
	sub.w	d3,d7
	cmp.w	d7,d5
	ble.s	ChMo2
	move.w	d7,d5
ChMo2:	move.w	d2,d6
	move.w	d3,d7
	and.w	#$fff8,d6
	move.w	d6,_mouse_minx
	add.w	#24,d6
	move.w	d6,_mouse_maxx
	move.w	d7,_mouse_miny
	add.w	#MouseH,d7
	move.w	d7,_mouse_maxy
	rts

*************************************************************************

MouseOn:
	tst.b	_mouse_stat
	bne.s	MoOn0
	movem.l	d0-d7/a0-a6,-(sp)
	st	_mouse_stat
	lea	ScrBitMap,a0
	lea	MouseBitMap,a1
	move.w	_mouse_x,d0
	move.w	_mouse_y,d1
	moveq	#0,d2
	moveq	#0,d3
	bsr.s	CheckMouse
	bsr.w	_BitMapCopy
	move.l	_mouse_ptr,a0
	lea	ScrBitMap,a1
	moveq	#0,d0
	moveq	#0,d1
	move.w	_mouse_x,d2
	move.w	_mouse_y,d3
	bsr.w	CheckMouse
	bsr.w	_BitMapCopy
	movem.l	(sp)+,d0-d7/a0-a6
MoOn0:	rts

*************************************************************************

MouseOff:
	tst.b	_mouse_stat
	beq.s	MoOf0
	movem.l	d0-d7/a0-a6,-(sp)
	sf	_mouse_stat
	lea	MouseBitMap,a0
	lea	ScrBitMap,a1
	moveq	#0,d0
	moveq	#0,d1
	move.w	_mouse_x,d2
	move.w	_mouse_y,d3
	bsr.w	CheckMouse
	bsr.w	_BitMapCopy
	movem.l	(sp)+,d0-d7/a0-a6
MoOf0:	rts

*************************************************************************

MouseNormal:
	lea	PointerBitMap,a0
	move.l	a0,_mouse_ptr
	bsr.s	MouseOff
	bra.w	MouseOn

*************************************************************************

MouseBusy:
	lea	BusyBitMap,a0
	move.l	a0,_mouse_ptr
	bsr.s	MouseOff
	bra.w	MouseOn

*************************************************************************

GetMouse:
	move.l	__Window,a0
	move.w	12(a0),d1
	move.w	14(a0),d0
	rts

*************************************************************************

MouseMove:
	bsr.s	GetMouse
	cmp.w	_old_mx,d0
	bne.s	MoMo1
	cmp.w	_old_my,d1
	bne.s	MoMo1
	rts
MoMo1:	tst.w	d0
	bpl.s	MoMo2
	moveq	#0,d0
MoMo2:	tst.w	d1
	bpl.s	MoMo3
	moveq	#0,d1
MoMo3:	cmp.w	ScrBitMap+bm_Width,d0
	bcs.s	MoMo4
	move.w	ScrBitMap+bm_Width,d0
	subq.w	#1,d0
MoMo4:	cmp.w	ScrBitMap+bm_Height,d1
	bcs.s	MoMo5
	move.w	ScrBitMap+bm_Height,d1
	subq.w	#1,d1
MoMo5:	move.w	d0,_old_mx
	move.w	d1,_old_my
	movem.w	d0-d1,-(sp)
	bsr.w	WaitTOF
	bsr.w	MouseOff
	movem.w	(sp)+,d0-d1
	move.w	d0,_mouse_x
	move.w	d1,_mouse_y
	bra.w	MouseOn

*************************************************************************

;In:
;	d0.w - x
;	d1.w - y
;Out:
;	a0.l - window
FindWindow:
	movea.l	#0,a1
	move.l	WinList,a0
FiWi1:	cmpa.l	#0,a0
	bne.s	FiWi2
	move.l	a1,a0
	rts
FiWi2:	cmp.w	wi_LeftEdge(a0),d0
	blt.s	FiWi3
	cmp.w	wi_TopEdge(a0),d1
	blt.s	FiWi3
	move.w	wi_LeftEdge(a0),d2
	add.w	wi_Width(a0),d2
	cmp.w	d2,d0
	bge.s	FiWi3
	move.w	wi_TopEdge(a0),d3
	add.w	wi_Height(a0),d3
	cmp.w	d3,d1
	bge.s	FiWi3
	move.l	a0,a1
FiWi3:	move.l	wi_Next(a0),a0
	bra.s	FiWi1

*************************************************************************

Install:
	lea	PointerBitMap,a0
	move.l	a0,_mouse_ptr
	lea	Pointer,a1
	move.w	#MouseW,bm_Width(a0)
	move.w	#MouseH,bm_Height(a0)
	move.w	#2,bm_BPR(a0)
	move.b	#DefDepth,bm_Depth(a0)
	move.b	#bmf_MASK,bm_Flags(a0)
	moveq	#DefDepth-1,d0
	lea	bm_Planes(a0),a2
Ins1:	move.l	a1,(a2)+
	add.l	#MouseH<<1,a1
	dbf	d0,Ins1
	move.l	a1,bm_Mask(a0)

	lea	BusyBitMap,a0
	lea	Busy,a1
	move.w	#MouseW,bm_Width(a0)
	move.w	#MouseH,bm_Height(a0)
	move.w	#2,bm_BPR(a0)
	move.b	#DefDepth,bm_Depth(a0)
	move.b	#bmf_MASK,bm_Flags(a0)
	moveq	#DefDepth-1,d0
	lea	bm_Planes(a0),a2
Ins2:	move.l	a1,(a2)+
	add.l	#MouseH<<1,a1
	dbf	d0,Ins2
	move.l	a1,bm_Mask(a0)

	lea	MouseBitMap,a0
	lea	MouseMem,a1
	move.w	#MouseW,bm_Width(a0)
	move.w	#MouseH,bm_Height(a0)
	move.w	#2,bm_BPR(a0)
	move.b	#DefDepth,bm_Depth(a0)
	move.b	#0,bm_Flags(a0)
	moveq	#DefDepth-1,d0
	lea	bm_Planes(a0),a2
Ins3:	move.l	a1,(a2)+
	add.l	#MouseH<<1,a1
	dbf	d0,Ins3

	lea	Font8BitMap,a0
	clr.b	bm_Width(a0)
	clr.b	bm_Height(a0)
	move.b	Fonts8+0,bm_Width+1(a0)
	move.b	Fonts8+1,bm_Height+1(a0)
	move.w	#1,bm_BPR(a0)
	move.b	#DefDepth,bm_Depth(a0)
	move.b	#bmf_MASK,bm_Flags(a0)

	lea	Font8BitMap,a0
	lea	Fonts8,a1
	move.l	a0,_fonts_bitmap
	move.l	a1,_fonts_data
	rts

*************************************************************************

;In:
;	d0.w - x
;	d1.w - y
;	d2.w - dx
;	d3.w - dy
RectDraw:
	bsr.w	MouseOff
	move.w	d0,_rect_x
	move.w	d1,_rect_y
	move.w	d2,_rect_dx
	move.w	d3,_rect_dy
	lea	ScrBitMap,a0
	lea	RectMem,a1
	moveq	#2,d4
	movem.l	d0-d3/a0,-(sp)
	bsr.w	Plane2Rect
	movem.l	(sp)+,d0-d3/a0
	bsr.w	_RectEOR
	bsr.w	MouseOn
	rts

*************************************************************************

RectRest:
	bsr.w	MouseOff
	move.w	_rect_x,d0
	move.w	_rect_y,d1
	move.w	_rect_dx,d2
	move.w	_rect_dy,d3
	lea	ScrBitMap,a0
	lea	RectMem,a1
	moveq	#2,d4
	bsr.w	Rect2Plane
	bsr.w	MouseOn
	rts

*************************************************************************

;In:
;	d0.w - dx
;	d1.w - dy
RectMove:
	cmp.w	_rect_x,d0
	bne.s	ReMo1
	cmp.w	_rect_y,d1
	beq.s	ReMo0
ReMo1:	movem.w	d0-d1,-(sp)
	bsr.s	RectRest
	movem.w	(sp)+,d0-d1
	move.w	_rect_dx,d2
	move.w	_rect_dy,d3
	bsr.w	RectDraw
ReMo0:	rts

*************************************************************************

;In:
;	a0.l - tekst,a0
;Out:
;	d7.w - size pxl
TextSize:
	move.l	_fonts_data,a6
	moveq	#0,d6
	move.b	(a6),d6
	moveq	#0,d7
TeSi1:	addq.w	#1,d7
	tst.b	(a0)+
	bne.s	TeSi1
	subq.w	#1,d7
	mulu.w	d6,d7
	rts

*************************************************************************

;In:
;	a0.l - window
CalcMenu:
	tst.l	wi_Menu(a0)
	beq.s	CaMe0
	move.l	wi_Menu(a0),a1
	move.w	#4,d0
CaMe1:	tst.l	(a1)
	beq.s	CaMe0
	move.l	(a1),a0
	bsr.s	TextSize
	move.w	d0,8(a1)
	move.w	d7,10(a1)
	add.w	#8,10(a1)

	moveq	#0,d2
	moveq	#2,d3

	tst.l	4(a1)
	beq.s	CaMe2
	move.l	4(a1),a2
CaMe3:	tst.l	(a2)
	beq.s	CaMe2
	move.l	(a2),a0
	bsr.s	TextSize
	cmp.w	d2,d7
	bls.s	CaMe4
	move.w	d7,d2
CaMe4:	move.w	d3,4(a2)
	move.w	d3,6(a2)
	add.w	#9,6(a2)
	add.w	#9,d3
	lea	12(a2),a2
	bra.s	CaMe3

CaMe2:	add.w	#14,d2
	add.w	#3,d3
	cmp.w	#MinMenuDx,d2
	bcc.s	CaMe5
	move.w	#MinMenuDx,d2
CaMe5:	move.w	d2,12(a1)
	move.w	d3,14(a1)

	add.w	d7,d0
	add.w	#10,d0
	lea	16(a1),a1
	bra.s	CaMe1
CaMe0:	rts

*************************************************************************

;In:
;	d0.w - dx
;	d1.w - dy
;Out:
;	d0.l - BitMapPtr
AllocBitMap:
	move.w	d0,_bm_dx
	move.w	d1,_bm_dy
	moveq	#BM_SIZE,d0
	bsr.w	AllocMem
	move.l	d0,_bm_ptr
	beq.w	AlBm0
	move.l	d0,a0
	move.w	_bm_dx,bm_Width(a0)
	move.w	_bm_dy,bm_Height(a0)
	move.w	_bm_dx,d0
	move.w	d0,d1
	lsr.w	#3,d0
	and.b	#7,d1
	beq.s	AlBm1
	addq.w	#1,d0
AlBm1:	move.w	d0,bm_BPR(a0)
	move.b	ScrBitMap+bm_Depth,bm_Depth(a0)
	clr.b	bm_Flags(a0)
	clr.l	bm_Mask(a0)
	move.w	bm_Height(a0),d0
	mulu.w	bm_BPR(a0),d0
	move.l	d0,_bm_size
	moveq	#7,d0
	lea	bm_Planes(a0),a1
AlBm2:	clr.l	(a1)+
	dbf	d0,AlBm2
	moveq	#0,d1
	move.b	ScrBitMap+bm_Depth,d1
	subq.w	#1,d1
	lea	bm_Planes(a0),a1
AlBm10:	move.l	_bm_size,d0
	movem.l	d1/a1,-(sp)
	bsr.w	AllocMem
	movem.l	(sp)+,d1/a1
	move.l	d0,(a1)+
	beq.s	AlBmErr
	dbf	d1,AlBm10
	move.l	_bm_ptr,d0
AlBm0:	rts

AlBmErr:
	move.l	_bm_ptr,a1
	lea	bm_Planes(a1),a1
	moveq	#7,d0
AlBm3:	move.l	(a1)+,a0
	movem.l	d0/a1,-(sp)
	bsr.w	FreeMem
	movem.l	(sp)+,d0/a1
	dbf	d0,AlBm3
	move.l	_bm_ptr,a0
	bsr.w	FreeMem
	moveq	#0,d0
	rts

*************************************************************************

;In:
;	a0.l - BitMapPtr
FreeBitMap:
	cmpa.l	#0,a0
	beq.s	FrBm0
	move.l	a0,-(sp)
	lea	bm_Planes(a0),a1
	moveq	#7,d1
FrBm1:	move.l	(a1)+,a0
	movem.l	d1/a1,-(sp)
	bsr.w	FreeMem
	movem.l	(sp)+,d1/a1
	dbf	d1,FrBm1
	move.l	(sp)+,a0
	move.l	a0,-(sp)
	move.l	bm_Mask(a0),a0
	bsr.w	FreeMem
	move.l	(sp)+,a0
	bsr.w	FreeMem
FrBm0:	rts

*************************************************************************
*************************************************************************

MsgLoop:
	move.l	__Window,a0
	move.l	$56(a0),a0
	CallExe	GetMsg
	tst.l	d0
	beq.s	SyLo0
	move.l	d0,a1
	move.l	$14(a1),d0
	move.w	$18(a1),d1
	move.w	$1a(a1),d2
	move.l	$1c(a1),a0
	movem.l	d0-d2/a0,-(sp)
	CallExe	ReplyMsg
	movem.l	(sp)+,d0-d2/a0
SyLo0:	rts

;Out:
;	d0.b - message
SystemLoop:
	bsr.w	MouseMove
	bsr.s	MsgLoop
	tst.l	d0
	beq.s	SyLo00
	cmp.l	#MOUSEBUTTONS,d0
	beq.s	SyLo1
	cmp.l	#RAWKEY,d0
	beq.s	SyLo2
SyLo00:	moveq	#0,d0
	rts
SyLo2:	st	d0
	rts
SyLo1:	btst	#7,d1
	bne.s	SyLo00
	btst	#0,d1
	bne.w	SL_Right

SL_Left:
	move.w	_mouse_x,d0
	move.w	_mouse_y,d1
	move.w	d0,_mem_x
	move.w	d1,_mem_y
	bsr.w	FindWindow
	cmpa.l	#0,a0
	beq.s	SyLo00
	bsr.w	WindowActive

	;czy belka okna

	move.l	ActWindow,a0
	move.w	_mouse_x,d0
	move.w	_mouse_y,d1
	sub.w	wi_LeftEdge(a0),d0
	sub.w	wi_TopEdge(a0),d1
	cmp.w	#11,d1
	bhi.w	SyLo50

	btst	#3,wi_Flags+1(a0)
	bne.w	SyLo10

	;ramka przesuwania

	move.w	wi_LeftEdge(a0),d0
	move.w	wi_TopEdge(a0),d1
	move.w	d0,_rect_sx
	move.w	d1,_rect_sy
	move.w	wi_Width(a0),d2
	move.w	wi_Height(a0),d3
	bsr.w	RectDraw

	;ruch okna

SyLo11:	bsr.w	MouseMove
	move.w	_mouse_x,d0
	move.w	_mouse_y,d1
	sub.w	_mem_x,d0
	sub.w	_mem_y,d1
	add.w	_rect_sx,d0
	add.w	_rect_sy,d1
	tst.w	d0
	bpl.s	SyLo40
	moveq	#0,d0
SyLo40:	tst.w	d1
	bpl.s	SyLo41
	moveq	#0,d1
SyLo41:	move.w	ScrBitMap+bm_Width,d2
	move.w	ScrBitMap+bm_Height,d3
	sub.w	_rect_dx,d2
	sub.w	_rect_dy,d3
	cmp.w	d2,d0
	bls.s	SyLo42
	move.w	d2,d0
SyLo42:	cmp.w	d3,d1
	bls.s	SyLo43
	move.w	d3,d1
SyLo43:	bsr.w	RectMove
	bsr.w	MsgLoop
	cmp.l	#MOUSEBUTTONS,d0
	bne.s	SyLo11

	bsr.w	RectRest

	move.w	_mouse_x,d0
	move.w	_mouse_y,d1
	sub.w	_mem_x,d0
	sub.w	_mem_y,d1
	move.l	ActWindow,a0
	add.w	wi_LeftEdge(a0),d0
	bpl.s	SyLo20
	moveq	#0,d0
SyLo20:	add.w	wi_TopEdge(a0),d1
	bpl.s	SyLo21
	moveq	#0,d1
SyLo21:	move.w	ScrBitMap+bm_Width,d2
	move.w	ScrBitMap+bm_Height,d3
	sub.w	wi_Width(a0),d2
	sub.w	wi_Height(a0),d3
	cmp.w	d2,d0
	bcs.s	SyLo22
	move.w	d2,d0
SyLo22:	cmp.w	d3,d1
	bcs.s	SyLo23
	move.w	d3,d1
SyLo23:	bsr.w	WindowMove

SyLo10:	bra.w	GadgetsGo

SyLo50:
	cmp.w	#20,d1
	bhi.s	SyLo10
	tst.l	wi_Menu(a0)
	beq.s	SyLo10
	move.l	a0,_mnu_win

	sf	_mnu_mnum
	sf	_mnu_snum
	clr.l	_mnu_bm

	move.w	_mouse_x,_mnu_x
	move.w	_mouse_y,_mnu_y
	sub.w	wi_LeftEdge(a0),d0
	sub.w	wi_TopEdge(a0),d1
	bsr.w	FindMenu
SyLo51:	bsr.w	MsgLoop
	cmp.l	#MOUSEBUTTONS,d0
	beq.w	SyLoEx
	bsr.w	MouseMove
	move.w	_mouse_x,d0
	move.w	_mouse_y,d1
	move.l	_mnu_win,a0
	sub.w	wi_LeftEdge(a0),d0
	sub.w	wi_TopEdge(a0),d1
	cmp.w	_mnu_x,d0
	bne.s	SyLo52
	cmp.w	_mnu_y,d1
	beq.s	SyLo51
SyLo52:	move.w	d0,_mnu_x
	move.w	d1,_mnu_y
	cmp.w	#13,d1
	bcs.s	SyLo60
	cmp.w	#20,d1
	bhi.s	SyLo60
	bsr.w	FindMenu
	tst.b	d7
	bne.s	SubMenuGo
	bra.s	SyLo51
SyLo60:	tst.b	_mnu_mnum
	beq.s	SyLo51

SubMenuGo:
	tst.l	_smnu_ptr
	beq.s	SyLo51

	move.w	_mouse_x,d0
	move.w	_mouse_y,d1
	cmp.w	_mnu_bmx,d0
	bcs.w	SyLo_2
	cmp.w	_mnu_bmy,d1
	bcs.w	SyLo_2
	move.w	_mnu_bmx,d2
	move.w	_mnu_bmy,d3
	add.w	_mnu_bmdx,d2
	add.w	_mnu_bmdy,d3
	cmp.w	d2,d0
	bcc.w	SyLo_2
	cmp.w	d3,d1
	bcc.w	SyLo_2

	sub.w	_mnu_bmy,d1

	move.l	_smnu_ptr,a2
	moveq	#1,d2

SyLo80:	tst.l	(a2)
	beq.w	SyLo_2
	cmp.w	4(a2),d1
	bcs.w	SyLo82
	cmp.w	6(a2),d1
	bhi.s	SyLo82

	cmp.b	_mnu_snum,d2
	beq.w	SyLo51

	bsr	MouseOff
	movem.l	d2/a2,-(sp)
	bsr	SubMenuOff
	movem.l	(sp)+,d2/a2
	move.b	d2,_mnu_snum
	move.l	a2,_mnu_mem

	move.l	_mnu_mem,a2
	lea	ScrBitMap,a0
	move.w	_mnu_bmx,d0
	move.w	4(a2),d1
	add.w	_mnu_bmy,d1
	move.w	_mnu_bmdx,d2
	move.w	#10,d3
	moveq	#6,d4
	addq.w	#3,d0
	subq.w	#6,d2
	movem.w	d0-d1,-(sp)
	bsr.w	_RectFill
	movem.w	(sp)+,d0-d1
	lea	ScrBitMap,a0
	move.l	_mnu_mem,a1
	move.l	(a1),a1
	addq.w	#4,d0
	addq.w	#1,d1
	moveq	#4,d2
	bsr.w	_PutText

	bsr	MouseOn
	bra.w	SyLo51

SyLo82:	lea	12(a2),a2
	addq.b	#1,d2
	bra.w	SyLo80

SyLo_2:	bsr	MouseOff
	bsr	SubMenuOff
	bsr	MouseOn
	bra.w	SyLo51

SubMenuOff:
	tst.b	_mnu_snum
	beq.s	SbMo0
	sf	_mnu_snum
	move.l	_mnu_mem,a2
	lea	ScrBitMap,a0
	move.w	_mnu_bmx,d0
	move.w	4(a2),d1
	add.w	_mnu_bmy,d1
	move.w	_mnu_bmdx,d2
	move.w	#10,d3
	moveq	#2,d4
	addq.w	#3,d0
	subq.w	#6,d2
	movem.w	d0-d1,-(sp)
	bsr.w	_RectFill
	movem.w	(sp)+,d0-d1
	lea	ScrBitMap,a0
	move.l	_mnu_mem,a1
	move.l	(a1),a1
	addq.w	#4,d0
	addq.w	#1,d1
	moveq	#0,d2
	bsr.w	_PutText
SbMo0:	rts

SyLoEx:
	bsr.w	MouseOff
	bsr.w	MenuOff
	bsr.w	MouseOn
	moveq	#0,d0
	rts

SL_Right:
	moveq	#0,d0
	rts

FindMenu:
	move.l	_mnu_win,a2
	move.l	wi_Menu(a2),a2
	move.w	_mnu_x,d0
	moveq	#1,d2
FiMe1:	tst.l	(a2)
	bne.s	FiMe2
FiMe0:	sf	d7
	rts
FiMe2:	move.w	8(a2),d1
	cmp.w	d1,d0
	bcs.w	FiMe3
	add.w	10(a2),d1
	cmp.w	d1,d0
	bhi.w	FiMe3
	cmp.b	_mnu_mnum,d2
	beq.s	FiMe0

	movem.l	d2/a2,-(sp)

	bsr.w	MouseOff
	move.l	_mnu_win,a0
	bsr.w	WindowLock

	bsr.w	MenuOff

	movem.l	(sp)+,d2/a2

	move.l	a2,_mnu_ptr
	move.b	d2,_mnu_mnum

	move.l	_mnu_ptr,a2
	move.w	8(a2),d0
	move.w	#13,d1
	move.w	10(a2),d2
	move.w	#8,d3
	moveq	#6,d4
	move.l	_mnu_win,a0
	bsr.w	RectFill

	move.l	_mnu_ptr,a2
	move.l	(a2),a1
	move.w	8(a2),d0
	addq.w	#4,d0
	move.w	#13,d1
	moveq	#4,d2
	move.l	_mnu_win,a0
	bsr.w	PutText

	move.l	_mnu_win,a0
	bsr.w	WindowUnLock

	bsr.s	SubMenuOn
	bsr.w	MouseOn

	st	d7
	rts

FiMe3:	lea	16(a2),a2
	addq.b	#1,d2
	bra.w	FiMe1

SubMenuOn:
	sf	_mnu_snum
	move.l	_mnu_ptr,a2
	tst.l	4(a2)
	beq.w	SuMo0
	move.l	_mnu_win,a0

	move.w	8(a2),d0
	add.w	wi_LeftEdge(a0),d0
	move.w	wi_TopEdge(a0),d1
	add.w	#21,d1
	move.w	12(a2),d2
	move.w	14(a2),d3

	move.w	ScrBitMap+bm_Height,d4
	move.w	d1,d5
	add.w	d3,d5
	cmp.w	d4,d5
	bls.s	SuMo10
	move.w	wi_TopEdge(a0),d1
	sub.w	d3,d1
	add.w	#13,d1
SuMo10:

	move.w	ScrBitMap+bm_Width,d4
	move.w	d0,d5
	add.w	d2,d5
	cmp.w	d4,d5
	bls.s	SuMo11
	move.w	d4,d0
	sub.w	d2,d0
SuMo11:

	move.w	d0,_mnu_bmx
	move.w	d1,_mnu_bmy
	move.w	d2,_mnu_bmdx
	move.w	d3,_mnu_bmdy

	move.w	_mnu_bmdx,d0
	move.w	_mnu_bmdy,d1
	bsr.w	AllocBitMap
	move.l	d0,_mnu_bm
	beq.w	SuMo0

	lea	ScrBitMap,a0
	move.l	_mnu_bm,a1
	move.w	_mnu_bmx,d0
	move.w	_mnu_bmy,d1
	moveq	#0,d2
	moveq	#0,d3
	move.w	_mnu_bmdx,d4
	move.w	_mnu_bmdy,d5
	bsr.w	_BitMapCopy

	lea	ScrBitMap,a0
	move.w	_mnu_bmx,d0
	move.w	_mnu_bmy,d1
	move.w	_mnu_bmdx,d2
	move.w	_mnu_bmdy,d3
	moveq	#4,d4
	moveq	#2,d5
	moveq	#0,d6
	bsr.w	_Bar3D

	move.l	_mnu_ptr,a2
	move.l	4(a2),a2
	move.l	a2,_smnu_ptr

SuMo70:	tst.l	(a2)
	beq.s	SuMo0
	move.l	(a2),a1
	lea	ScrBitMap,a0
	move.w	_mnu_bmx,d0
	addq.w	#7,d0
	move.w	_mnu_bmy,d1
	add.w	4(a2),d1
	addq.w	#1,d1
	moveq	#0,d2
	move.l	a2,-(sp)
	bsr.w	_PutText
	move.l	(sp)+,a2
	lea	12(a2),a2
	bra.s	SuMo70

SuMo0:	rts

MenuOff:
	tst.b	_mnu_mnum
	beq.w	MeOf0

	move.l	_mnu_ptr,a2
	move.w	8(a2),d0
	move.w	#13,d1
	move.w	10(a2),d2
	move.w	#8,d3
	moveq	#2,d4
	move.l	_mnu_win,a0
	bsr.w	RectFill

	move.l	_mnu_ptr,a2
	move.l	(a2),a1
	move.w	8(a2),d0
	addq.w	#4,d0
	move.w	#13,d1
	moveq	#0,d2
	move.l	_mnu_win,a0
	bsr.w	PutText

	clr.b	_mnu_mnum

	tst.l	_mnu_bm
	beq.s	MeOf0

	move.l	_mnu_bm,a0
	lea	ScrBitMap,a1
	moveq	#0,d0
	moveq	#0,d1
	move.w	_mnu_bmx,d2
	move.w	_mnu_bmy,d3
	move.w	_mnu_bmdx,d4
	move.w	_mnu_bmdy,d5
	bsr.w	_BitMapCopy

	move.l	_mnu_bm,a0
	bsr.w	FreeBitMap

MeOf0:	rts

GadgetsGo:
	move.l	ActWindow,a0
	lea	wi_Gadgets(a0),a2
GaGo1:	tst.l	(a2)
	beq.s	GaGo0
	move.l	(a2),a2

	btst	#1,gd_Flags(a2)
	bne.s	GaGo1

	move.w	gd_LeftEdge(a2),d2
	move.w	gd_TopEdge(a2),d3
	cmp.w	d2,d0
	bcs.s	GaGo1
	cmp.w	d3,d1
	bcs.s	GaGo1
	add.w	gd_Width(a2),d2
	add.w	gd_Height(a2),d3
	cmp.w	d2,d0
	bcc.s	GaGo1
	cmp.w	d3,d1
	bcc.s	GaGo1

	bchg	#0,gd_Flags(a2)
	move.l	ActWindow,a0

	movem.l	a0/a2,-(sp)

	bsr.w	DrawGadget

GGLoop:
	bsr.w	MouseMove
	bsr.w	MsgLoop
	cmp.l	#MOUSEBUTTONS,d0
	bne.s	GGLoop

	movem.l	(sp)+,a0/a2

	btst	#2,gd_Flags(a2)
	bne.s	GaGo0

	move.l	ActWindow,a0
	bclr	#0,gd_Flags(a2)
	bsr.w	DrawGadget

GaGo0:	moveq	#0,d0
	rts

*************************************************************************

IMAGES_IL	EQU	2

InstallImages:
	lea	ImagesBitMap,a0
	lea	ImagesData,a1
	move.l	a1,d1
	moveq	#0,d0
InIm1:	add.l	d1,bm_Planes+00(a0)
	add.l	d1,bm_Planes+04(a0)
	add.l	d1,bm_Planes+08(a0)
	add.l	d1,bm_Planes+12(a0)
	tst.l	bm_Mask(a0)
	beq.s	InIm2
	add.l	d1,bm_Mask(a0)
InIm2:	lea	BM_SIZE(a0),a0
	addq.w	#1,d0
	cmp.w	#IMAGES_IL,d0
	bne.s	InIm1
	rts

*************************************************************************

;In:
;	a0.l - window
DrawGadgets:
	tst.l	wi_Gadgets(a0)
	beq.s	DrGa0
	move.l	a0,_gdg_win
	bsr.w	MouseOff
	move.l	_gdg_win,a0
	bsr.w	WindowLock
	move.l	_gdg_win,a0
	bsr	ClipRegMem
	move.l	_gdg_win,a0
	bsr.s	_DrawGadgets
	move.l	_gdg_win,a0
	bsr.w	ClipRegRes
	move.l	_gdg_win,a0
	bsr.w	WindowUnLock
	bsr.w	MouseOn
DrGa0:	rts

;In:
;	a0.l - window
_DrawGadgets:
	tst.l	wi_Gadgets(a0)
	beq.s	DrGa0
	move.l	a0,_gdg_win
	move.l	wi_Gadgets(a0),a2
DrGa1:	cmpa.l	#0,a2
	beq.s	DrGa0
	move.b	gd_Type(a2),d4
	move.l	a2,-(sp)
	move.l	_gdg_win,a0
	bsr.s	_DrawGadget
	move.l	(sp)+,a2
DrGa2:	move.l	gd_Next(a2),a2
	bra.s	DrGa1
DGBOX:	bsr.s	DG_BOX
	bra.s	DrGa2

*************************************************************************

;In:
;	a0.l - window
;	a2.l - gadget
DrawGadget:
	move.l	a0,_gdg_win
	bsr.w	MouseOff
	bsr.w	WindowLock
	move.l	a0,_gdg_win
	bsr	ClipRegMem
	move.l	_gdg_win,a0
	bsr.s	_DrawGadget
	move.l	_gdg_win,a0
	bsr.w	ClipRegRes
	move.l	_gdg_win,a0
	bsr.w	WindowUnLock
	bsr.w	MouseOn
	rts

_DrawGadget:
	move.b	gd_Type(a2),d7
	cmp.b	#gt_BOX,d7
	beq.s	DG_BOX
	rts

DG_BOX:
	move.w	gd_LeftEdge(a2),d0
	move.w	gd_TopEdge(a2),d1
	move.w	gd_Width(a2),d2
	move.w	gd_Height(a2),d3
	lea	GD_SIZE(a2),a3
	btst	#0,gd_Flags(a2)
	beq.s	DgBo1
	lea	2(a3),a3
DgBo1:	move.b	(a3)+,d4
	move.b	(a3)+,d5
	bsr.w	Box3D
	rts

*************************************************************************
*************************************************************************

Test:
	jsr	Install
	jsr	InstallImages
	jsr	Backdrop

	lea	Window1,a0
	move.w	ScrBitMap+bm_Width,nw_Width(a0)
	move.w	ScrBitMap+bm_Height,nw_TopEdge(a0)
	sub.w	#23,nw_TopEdge(a0)
	jsr	WindowOpen
	move.l	d0,W1

	lea	Window2,a0
	jsr	WindowOpen
	move.l	d0,W2
	lea	Window3,a0
	jsr	WindowOpen
	move.l	d0,W3

	jsr	MouseNormal

Loop:	jsr	SystemLoop
	tst.b	d0
	beq.s	Loop
	rts

Delay:
	move.l	#500000,d0
Del:	subq.l	#1,d0
	bne.s	Del
	rts

W1:	ds.l	1
W2:	ds.l	1
W3:	ds.l	1

Window1:
	dc.l	Win1Name,Win1Menu,0,0
	dc.w	0,0,0,23
	dc.w	0,0,0,0
	dc.w	0

Win1Menu:
	dc.l	MTxt1,MSub1,0,0
	dc.l	MTxt2,MSub2,0,0
	dc.l	0
MSub1:	dc.l	MTxt11,0,0
	dc.l	MTxt12,0,0
	dc.l	0
MSub2:	dc.l	MTxt21,0,0
	dc.l	MTxt22,0,0
	dc.l	MTxt23,0,0
	dc.l	0
MTxt1:	dc.b	'Pliki',0
MTxt2:	dc.b	'Edycja',0
MTxt11:	dc.b	'Odczyt',0
MTxt12:	dc.b	'Zapis',0
MTxt21:	dc.b	'Mark',0
MTxt22:	dc.b	'Copy',0
MTxt23:	dc.b	'Cut',0
	EVEN

GfxList1:
	dc.b	gl_END

Win1Name:
	dc.b	'LinkOperatingSystem V1.0',0
	EVEN

Window2:
	dc.l	Win2Name,Win2Menu,Gadgets2,GfxList2
	dc.w	220,80,204,100
	dc.w	0,0,0,0
	dc.w	0

GfxList2:
	dc.b	gl_BAR3D,1,2,3
	dc.w	2,22,200,76

	dc.b	gl_IMAGE,0
	dc.w	30,30
	dc.l	0*BM_SIZE+ImagesBitMap

	dc.b	gl_IMAGE,0
	dc.w	100,30
	dc.l	1*BM_SIZE+ImagesBitMap

	dc.b	gl_BOX,0
	dc.w	93,26,46,46

	dc.b	gl_END
	EVEN

Gadgets2:
	dc.l	Gadgets22,0,0
	dc.w	26,27,44,44
	dc.b	gt_BOX,gf_SWITCH
	dc.b	3,1,1,3

Gadgets22:
	dc.l	0,0,0
	dc.w	94,27,44,44
	dc.b	gt_BOX,0
	dc.b	4,1,1,2

Win2Menu:
	dc.l	M2Txt1,M2Sub1,0,0
	dc.l	M2Txt2,M2Sub2,0,0
	dc.l	0
M2Sub1:	dc.l	M2Txt11,0,0
	dc.l	M2Txt12,0,0
	dc.l	0
M2Sub2:	dc.l	M2Txt21,0,0
	dc.l	M2Txt22,0,0
	dc.l	M2Txt23,0,0
	dc.l	0
M2Txt1:	dc.b	'File',0
M2Txt2:	dc.b	'Edit',0
M2Txt11:	dc.b	'Load',0
M2Txt12:	dc.b	'Save',0
M2Txt21:	dc.b	'Zaznacz',0
M2Txt22:	dc.b	'Kopiuj',0
M2Txt23:	dc.b	'Tnij',0
	EVEN

Win2Name:	dc.b	'Edycja',0
	EVEN

Window3:
	dc.l	Win3Name,0,0,0
	dc.w	30,20,200,50
	dc.w	0,0,0,0
	dc.w	0

Win3Name:	dc.b	'Pliki',0
	EVEN

*************************************************************************

Begin:
	move.l	a7,MemStack
	move.l	4,ExcBase

	jmp	NoWB

*---	obsluga jesli z WB

	movea.l	#0,a1
	CallExe	FindTask
	move.l	d0,a4
	tst.l	172(a4)
	bne.s	NoWB
	lea	92(a4),a0
	CallExe	WaitPort
	lea	92(a4),a0
	CallExe	GetMsg
	move.l	d0,WBMessage
NoWB:

*---	otwarcie dos.library

	lea	DosName,a1
	CallExe	OldOpenLibrary
	move.l	d0,DosBase
	beq.w	Quit

*---	otwarcie intuition.library

	lea	IntName,a1
	CallExe	OldOpenLibrary
	move.l	d0,IntBase
	beq.w	Err1

*---	otwarcie graphics.library

	lea	GfxName,a1
	CallExe	OldOpenLibrary
	move.l	d0,GfxBase
	beq.w	Err2

*---	odczyt naglowka pliku

	move.l	#ProgramName,d1
	move.l	#MODE_OLD,d2
	CallDos	Open
	move.l	d0,FileHandle
	beq.w	Error

	move.l	FileHandle,d1
	move.l	#_StartPtr,d2
	move.l	#20,d3
	CallDos	Read
	cmp.l	#20,d0
	bne.w	Error

*---	dlugosc do odczytu i rozmiar pamieci

	move.l	_BSSPtr,d0
	sub.l	_CodePtr,d0
	move.l	d0,ProgramLen

	move.l	_StopPtr,d0
	sub.l	_CodePtr,d0
	move.l	d0,MemoryLen

*---	pamiec dla programu

	move.l	ProgramLen,d0
	move.l	#MEM_PUBLIC,d1
	CallExe	AllocMem
	move.l	d0,MemoryPtr
	beq.w	Error

*---	odczyt programu

	move.l	FileHandle,d1
	move.l	MemoryPtr,d2
	move.l	ProgramLen,d3
	CallDos	Read
	cmp.l	ProgramLen,d3
	bne.w	Error

*---	zamkniecie pliku

	move.l	FileHandle,d1
	CallDos	Close
	clr.l	FileHandle

*---	zmiana wskaznikow programu

	move.l	_CodePtr,CodePtr
	move.l	_DataPtr,DataPtr
	move.l	_BSSPtr,BSSPtr
	move.l	_StopPtr,StopPtr

	move.l	MemoryPtr,d0
	sub.l	_CodePtr,d0
	move.l	d0,Delta

	add.l	d0,CodePtr
	add.l	d0,DataPtr
	add.l	d0,BSSPtr
	add.l	d0,StopPtr

*---	reasemblacja

	nop

*---	parametry ekranu

	move.w	#DefWidth,ScrWidth
	move.w	#DefHeight,ScrHeight
	move.w	#DefVModes,ScrViewModes

*---	otwarcie ekranu

	move.w	ScrWidth,New_Screen+4
	move.w	ScrHeight,New_Screen+6
	move.w	ScrWidth,New_Window+4
	move.w	ScrHeight,New_Window+6
	move.w	ScrViewModes,New_Screen+12
	lea	New_Screen,a0
	CallInt	OpenScreen
	move.l	d0,__Screen
	move.l	d0,New_Window+30
	beq.w	Error
	
	move.l	__Screen,a0
	move.l	326(a0),_memscrgdg
	clr.l	326(a0)

	move.w	ScrWidth,d0
	lsr.w	#3,d0
	move.w	d0,ScrBitMap+bm_BPR
	move.w	ScrWidth,ScrBitMap+bm_Width
	move.w	ScrHeight,ScrBitMap+bm_Height
	move.b	#DefDepth,ScrBitMap+bm_Depth

	move.l	__Screen,a0
	lea	184(a0),a0
	lea	8(a0),a0
	lea	ScrBitMap+bm_Planes,a1
	moveq	#3,d0
skok1:	move.l	(a0)+,(a1)+
	dbf	d0,skok1

*---	otwarcie backdrop

	lea	New_Window,a0
	CallInt	OpenWindow
	move.l	d0,__Window
	beq.w	Error2

*---	usuniecie myszy

	move.l	__Window,a0
	lea	ClrPointer,a1
	moveq	#0,d0
	moveq	#0,d1
	moveq	#0,d2
	moveq	#0,d3
	CallInt	SetPointer

*---	defaultowe kolory

	move.l	__Screen,a0
	lea	44(a0),a0
	lea	Palette,a1
	moveq	#0,d0
	moveq	#0,d1
	moveq	#0,d2
	moveq	#0,d3
skok2:	move.b	(a1)+,d1
	move.b	(a1)+,d2
	move.b	(a1)+,d3
	movem.l	d0-d3/a0-a1,-(sp)
	CallGfx	SetRGB4
	movem.l	(sp)+,d0-d3/a0-a1
	addq.b	#1,d0
	cmp.b	#1<<DefDepth,d0
	bne.s	skok2

*---	uruchomienie programu uzytkownika

	lea	StackEnd,a7
	moveq	#-1,d6
	lea	Procedures,a6
	move.l	CodePtr,a0
;	jsr	(a0)
	jsr	Test

*---	zakonczenie programu

_Halt:

skok3:	tst.l	MemList
	beq.s	skok4
	move.l	MemList,a1
	move.l	(a1),MemList
	move.l	4(a1),d0
	CallExe	FreeMem
	bra	skok3
skok4:

*---	blad uruchomienia, zakonczenie

	move.l	__Window,a0
	CallInt	CloseWindow

Error2:
	move.l	__Screen,a0
	move.l	_memscrgdg,326(a0)
	CallInt	CloseScreen

Error:
	move.l	FileHandle,d1
	beq	NoFile
	CallDos	Close
NoFile:

	move.l	MemoryPtr,d1
	beq.s	NoMem
	move.l	d1,a1
	move.l	MemoryLen,d0
	CallExe	FreeMem
NoMem:

*---	zamkniecie graphics.library

Err3:	move.l	GfxBase,a1
	CallExe	CloseLibrary

*---	zamkniecie intuition.library

Err2:	move.l	IntBase,a1
	CallExe	CloseLibrary

*---	zamkniecie dos.library

Err1:	move.l	DosBase,a1
	CallExe	CloseLibrary

Quit:	tst.l	WBMessage
	beq.s	NoWBQ

*---	odeslanie wiadomosci

	CallExe	Forbid
	move.l	WBMessage,a1
	CallExe	ReplyMsg

*---	wyjscie

NoWBQ:	move.l	MemStack,a7
	moveq	#0,d0
	rts

*************************************************************************

	SECTION	DATA,DATA

SMenuWin:
	dc.l	0,0,0,0
	dc.w	0,0,200,50
	dc.w	0,0,0,0
	dc.w	0

ActWindow:	dc.l	0
MemList:	dc.l	0
WinList:	dc.l	0

_mouse_x:	dc.w	0
_mouse_y:	dc.w	0
_old_mx:	dc.w	0
_old_my:	dc.w	0

_mouse_stat:	dc.b	0
	EVEN

ScrBitMap:	blk.b	BM_SIZE

New_Screen:
	dc.w	0,0,0,0,DefDepth
	dc.b	0,0
	dc.w	0,$10f
	dc.l	0,0,0,0

New_Window:
	dc.w	0,0,0,0
	dc.b	0,0
	dc.l	MOUSEBUTTONS+RAWKEY,$100+$800+$10000,0,0,0,0,0
	dc.w	0,0,0,0,$f

Palette:
	dc.b	$0,$0,$0
	dc.b	$6,$6,$6
	dc.b	$9,$9,$9
	dc.b	$b,$b,$b
	dc.b	$f,$f,$f
	dc.b	$f,$0,$0
	dc.b	$0,$0,$8
	dc.b	$0,$8,$8
	dc.b	$f,$f,$0
	dc.b	$f,$f,$0
	dc.b	$f,$f,$0
	dc.b	$f,$f,$0
	dc.b	$f,$f,$0
	dc.b	$f,$f,$0
	dc.b	$f,$f,$0
	dc.b	$f,$f,$0
	EVEN

*-----------------------------------------------------------------------*

WBMessage:	dc.l	0
FileHandle:	dc.l	0
MemoryPtr:	dc.l	0

DosName:	dc.b	'dos.library',0
IntName:	dc.b	'intuition.library',0
GfxName:	dc.b	'graphics.library',0
ProgramName:	dc.b	'program',0
	EVEN

Font8BitMap:	blk.b	BM_SIZE,0
Fonts8:		incbin	"BIN/Fonts8.BIN"
	EVEN

PointerBitMap:	blk.b	BM_SIZE,0
Pointer:	incbin	"BIN/Pointer.BIN"
	EVEN

BusyBitMap:	blk.b	BM_SIZE,0
Busy:		incbin	"BIN/Busy.BIN"
	EVEN

CloseBitMap:	blk.b	BM_SIZE,0
Close:		incbin	"BIN/Close.BIN"

MouseBitMap:	blk.b	BM_SIZE,0
_font_clr:	blk.b	16,0

ClrPointer:	blk.b	32,0

ImagesBitMap:	incbin	"BIN/ImageBitMap.BIN"
ImagesData:	incbin	"BIN/ImageData.BIN"

*************************************************************************

	SECTION	BSS,BSS

_gdg_win:	ds.l	1

_mnu_mem:	ds.l	1
_smnu_ptr:	ds.l	1
_mnu_bm:	ds.l	1
_mnu_bmx:	ds.w	1
_mnu_bmy:	ds.w	1
_mnu_bmdx:	ds.w	1
_mnu_bmdy:	ds.w	1
_mnu_win:	ds.l	1
_mnu_ptr:	ds.l	1
_mnu_x:		ds.w	1
_mnu_y:		ds.w	1
_mnu_mnum:	ds.b	1
_mnu_snum:	ds.b	1

_bm_ptr:	ds.l	1
_bm_size:	ds.l	1
_bm_dx:		ds.w	1
_bm_dy:		ds.w	1

_rect_x:	ds.w	1
_rect_y:	ds.w	1
_rect_sx:	ds.w	1
_rect_sy:	ds.w	1
_rect_dx:	ds.w	1
_rect_dy:	ds.w	1

_fonts_bitmap:	ds.l	1
_fonts_data:	ds.l	1
_new_window:	ds.l	1
_window:	ds.l	1
_plane_size:	ds.l	1
_bit_map:	ds.l	1
__win:		ds.l	1
_clip_minx:	ds.w	1
_clip_miny:	ds.w	1
_clip_maxx:	ds.w	1
_clip_maxy:	ds.w	1
_bm_x:		ds.w	1
_bm_y:		ds.w	1
_mouse_ptr:	ds.l	1
_mouse_minx:	ds.w	1
_mouse_miny:	ds.w	1
_mouse_maxx:	ds.w	1
_mouse_maxy:	ds.w	1
_mem_x:		ds.w	1
_mem_y:		ds.w	1

__Screen:	ds.l	1
__Window:	ds.l	1
ScrWidth:	ds.w	1
ScrHeight:	ds.w	1
ScrViewModes:	ds.w	1

Copy1Mem:	ds.b	164
Copy2Mem:	ds.b	164
Copy3Mem:	ds.b	164
Copy4Mem:	ds.b	164

RectMem:	ds.b	2048

MouseMem:	ds.b	MouseH<<3

*-----------------------------------------------------------------------*

*---	zmienne uruchomienia

MemStack:	ds.l	1
ExcBase:	ds.l	1
DosBase:	ds.l	1
IntBase:	ds.l	1
GfxBase:	ds.l	1
MemoryLen:	ds.l	1
ProgramLen:	ds.l	1
Delta:		ds.l	1
_memscrgdg:	ds.l	1

*---	rzeczywiste wskaniki

StartPtr:	ds.l	1
CodePtr:	ds.l	1
DataPtr:	ds.l	1
BSSPtr:		ds.l	1
StopPtr:	ds.l	1

*---	wskaniki po kompilacji

_StartPtr:	ds.l	1
_CodePtr:	ds.l	1
_DataPtr:	ds.l	1
_BSSPtr:	ds.l	1
_StopPtr:	ds.l	1

*---	stos

StackBeg:	ds.b	10240
StackEnd:

*************************************************************************

	END
